        SUBROUTINE alm_phi(Nmx,Nmp,Jmx,Lmx,Vnyq,Nx,
     +                  Nph,f,phi2,phi,apm,bpm)
C   loop over m - SUM_m[a_{lm}e^{i m phi}]
      IMPLICIT REAL*8(a-h,o-y), COMPLEX*16(z)
      DIMENSION phi(Nmp)                
      DIMENSION f(Nmx,Nmp),Nph(Nmx)      
      DIMENSION apm(0:Jmx,Nmx),bpm(0:Jmx,Nmx)

        Nphi=Nph(1)
        call set_phi(Nphi,phi2,phi,dphi)
        Mx=Vnyq*Nphi
        if(Mx.gt.Lmx) Mx=Lmx
        DO m=0,Mx
           DO iq=1,Nphi
             zphi1=(0.,1.)*phi(iq)
             ze=exp(m*zphi1)
             DO ix=1,Nx
               apm(m,ix)=apm(m,ix)+f(ix,iq)*real(ze)
               bpm(m,ix)=bpm(m,ix)+f(ix,iq)*imag(ze)
             ENDDO              !end of the loop over ix 
           ENDDO                !end of the loop over phi 
           apm(m,ix)=-apm(m,ix)
        ENDDO           !end of the loop over m 
        return
        end
C-----------------------------------------------------------
        SUBROUTINE alm_fast3(Nmx,Nmp,Nx,Jmx,Lmx,Vnyq,
     +                  Nph,f,c,apm,bpm,wsave)
C   fast loop over m - SUM_m[a_{lm}e^{i m phi}]
        IMPLICIT REAL*8(a-h,o-y)
        DIMENSION f(Nmx,Nmp),Nph(Nmx)
        DIMENSION c(Nmp),wsave(2*Nmp+15)
        DIMENSION apm(0:Jmx,Nmx),bpm(0:Jmx,Nmx)

C    input: map f(i,j), Nph - number of cells vs. x, 
C           Lmx - upper limit for m
C  service: c, wsave
C   output: zpm - complex fourier image of the map

        DO ix=1,Nx              !  loop over x
          DO ip=1,Nph(ix)
             c(ip)=f(ix,ip)
          ENDDO
          call RFFTI(Nph(ix),wsave)
          call RFFTF(Nph(ix),c,wsave)
          apm(0,ix)=c(1)
          Mx=Vnyq*Nph(ix)
          if(Mx.gt.Lmx) Mx=Lmx
          DO iz=1,Mx
            apm(iz,ix)=-c(2*iz)
            bpm(iz,ix)=c(2*iz+1)
          ENDDO
        ENDDO  !   END over ix
      return
      end
C  -------------------------------------------------------              
      SUBROUTINE set_phi(Nphi,phi2,phi,dph)
        IMPLICIT REAL*8(a-h,o-z)
        dimension phi(Nphi)
C   set of phi, 0< phi< phi2 through Nphi points
          dph=phi2/(Nphi-0.d0)
          pp=0
          do i=1,Nphi
            phi(i)=pp
            pp=pp+dph
          enddo
        if(phi(Nphi).gt.phi2) phi(Nphi)=phi2
        return
        end
C  -------------------------------------------------------              
      SUBROUTINE gauleg(x1,x2,x,w,n)
        IMPLICIT REAL*8(a-h,o-z)
      INTEGER n
      dimension x(n),w(n)
      PARAMETER (EPS=3.d-15)
      INTEGER i,j,m
        pi=4.d0*atan(1.d0)
      m=(n+1)/2
      xm=0.5d0*(x2+x1)
      xl=0.5d0*(x2-x1)
      do 12 i=1,m
        z=cos(pi*(i-.25d0)/(n+.5d0))
1       continue
          p1=1.d0
          p2=0.d0
          do 11 j=1,n
            p3=p2
            p2=p1
            p1=((2.d0*j-1.d0)*z*p2-(j-1.d0)*p3)/j
11        continue
          pp=n*(z*p1-p2)/(z*z-1.d0)
          z1=z
          z=z1-p1/pp
        if(abs(z-z1).gt.EPS)goto 1
        x(i)=xm-xl*z
        x(n+1-i)=xm+xl*z
        w(i)=2.d0*xl/((1.d0-z*z)*pp*pp)
        w(n+1-i)=w(i)
12    continue
      return
      END

