# include <stdio.h>
# include <stdlib.h>
# include <math.h>

# include "glesp.h"

#define PR  fprintf

/*
 * R(l)=1/(L-1)*SUM_{m=1,L}cos(PHASAPCM_{lm}-FOREGROUND_{lm})
 *
 */
void corr_phase(r, alm1, alm2, nbuf, lmax, sin_flag)
double *r;
double *alm1, *alm2;
int nbuf, lmax;
int sin_flag;
{
    register int l, m;
    for(l=1; l<=lmax; l++) {
	int ll = l * nbuf, lm = ll + lmax + 1;
	double s = 0.0;
	for(m=1; m<=l; m++) {
	    double re1 = alm1[ll+m], im1 = alm1[lm+m],
		   re2 = alm2[ll+m], im2 = alm2[lm+m];
	    double ph1 = ph_calc(re1, im1),
		   ph2 = ph_calc(re2, im2);
	    if (sin_flag)
		s += sin(ph1-ph2);
	    else
		s += cos(ph1-ph2);
	}
	r[l] = s / l;
    }
}

void k_l_nn(alm1, alm2, lmax, nbuf, fp_d, nn)
double *alm1, *alm2;
int lmax, nbuf;
FILE *fp_d;
int nn;     /* shift by nn */
{
    register int l, m;
    int lmax_nn = lmax - nn;

    for(l=2; l<=lmax_nn; l++) {
	register int ll  = l * nbuf;
	register int lln = (l+nn) * nbuf;
	double s1 = 0.0, s2a = 0.0, s2b = 0.0, v;

	s1  += alm1[ll] * alm2[ll];
	s2a += alm1[ll] * alm1[ll];
	s2b += alm2[ll] * alm2[ll];
	for(m=1; m<=l; m++) {
	    double re1 = alm1[ll+m],  im1 = alm1[ll+m+lmax+1];
	    double re2 = alm2[lln+m], im2 = alm2[lln+m+lmax+1];

	    s1  += 2 * (re1 * re2 + im1 * im2);
	    s2a += 2 * (re1*re1 + im1*im1);
	    s2b += 2 * (re2*re2 + im2*im2);
	}
	v = s1 / sqrt(s2a*s2b);
	PR(fp_d, "%4d %7.4f\n", l,  v);
    }

    return;
}


