#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <math.h>

#define PR      fprintf
#define ER      stderr

extern void short_form(char *);

extern char inp_file[161];  /* intput file for F(x,phi) or  a_{lm}    */
extern char outp_file[161]; /* output file for a_{lm} or F(x,phi)     */
extern int  calc_flag;      /* > 0,transforms a_lm to map, else back  */
extern int  calc_grid;      /* <0 - dx=2/(Nx-1), >0 - special grid    */
extern int  calc_number;    /* number of calculation                  */
extern int  num_x;          /* number of points along cos(theta)      */
extern int  num_phi;        /* number of points along phi             */
extern int  l_min;          /* Lmin                                   */
extern int  l_max;          /* Lmax                                   */
extern int  m_min;          /* Mmin                                   */
extern int  m_max;          /* Mmax                                   */
extern int  l_calc;         /* index of input harmonique for f(x,phi) */
extern int  m_calc;         /* index of input harmonique for f(x,phi) */

extern char *myname;

void read_pars_file(filename)
char *filename;
{
	register char *cs;
	register FILE *fp;
	register int i, c;
	int sep_s1 = '*',       /* separator 1 */
	    sep_s3 = ';',       /* separator 3 */
	    sep_s4 = ';',       /* separator 4 */
	    sep_m  = '=';

	char str[161], str1[121], buf[121], buf2[121];


	if ((fp = fopen(filename, "r")) == (FILE *)0) {
		PR(ER, "%s: can not open file '%s'\n", myname, filename);
		exit(2);
	}

	while (fgets(str, 160, fp) != NULL) {
		int st_len = strlen(str) - 1;

		/* miss empty or comments string */
		if ( *str == '#' ||  *str == '%' || *str == '\r'
		  || *str == '\n')
			continue;

		str[st_len] = '\0';  /* instead of '\n' */

		/* delete comments at the string's end */
		for(i=0; i < st_len; i++) {
			if ( str[i] == '#' ) {
				str[i] = '\0';
				st_len = i;
				break;
			}
			if (i > 0 && (str[i] == '-' || str[i] == '/') &&
			    (str[i-1] == ' ' || str[i-1] == '\t') &&
			    (str[i+1] == ' ' || str[i+1] == '\t') ){
				str[i] = '\0';
				st_len = i;
				break;
			}
		}

next_substring:
		/********************/
		/* miss ' ' symbols */
		/********************/

		/* from the begining */
		c = i = 0;
		while((str[i] == sep_s4 || str[i] == ' ' || str[i] == '\t')
		    && str[i] )   i++;
		while( (str[c] = str[i]) ) {
			c++;
			i++;
		}
		st_len = c;
		/* from the end */
		while( str[st_len] == ' ' || str[st_len] == '\t')
			st_len--;
		str [ ++st_len ] = '\0';

		/*---------------------------*/
		/* get string for operations */
		/*---------------------------*/
		i = 0;
		while((c=str1[i]=str[i]) != sep_s3 && c != sep_s4 && c)
			i++;
		if ( c )  str1[i] = '\0';


		/* continue loop */
		if ( !i )  /* empty string */
			continue;


		/* change main string */
		c = 0;
		while ( (str[c] = str[i]) ) {
			c++;
			i++;
		}

		/**************/
		/* operations */
		/**************/

		/* read parameters */

		cs = buf;
		i = 0;
		/* miss some symbols */
		while( (c=str1[i++]) == ' ' || c == '\t'
		    || c == '\r') ;
		i--;
		/* read 1st keyword till symbol 'sep_s1' or 'sep_m'*/
		while(((*cs++ =c=str1[i++])!=sep_s1&&c!=sep_m) && c);
		cs--;
		if ( *cs == '\0' )  c = -1;
		*cs = '\0'; /* delete symbol '*' at the buf end */

		if(c == -1) {
			;
		}
		/* save value of keywod to buf2 */
		/* and squeeze strings          */
		strcpy(buf2, str1+i);
		short_form(buf);
		short_form(buf2);

		/* upper letters instead of low */
		cs=buf; while(*cs) { *cs = toupper (*cs); cs++; }

		/*-------------------*/
		/* define what it is */
		/*-------------------*/
		if (strcmp(buf, "INPFILE") == 0)
			strcpy(inp_file, buf2);
		else if (strcmp(buf, "OUTPFILE") == 0)
			strcpy(outp_file, buf2);

		else if (strcmp(buf, "CALCFLAG") == 0)
			calc_flag = atoi(buf2);
		else if (strcmp(buf, "CALCGR") == 0)
			calc_grid = atoi(buf2);
		else if (strcmp(buf, "CALCNUM") == 0)
			calc_number = atoi(buf2);

		else if (strcmp(buf, "NUM-X") == 0)
			num_x = atoi(buf2);
		else if (strcmp(buf, "NUM-PHI") == 0)
			num_phi = atoi(buf2);

		else if (strcmp(buf, "LMIN") == 0)
			l_min = atoi(buf2);

		else if (strcmp(buf, "LMAX") == 0)
			l_max = atoi(buf2);

		else if (strcmp(buf, "MMIN") == 0)
			m_min = atoi(buf2);

		else if (strcmp(buf, "MMAX") == 0)
			m_max = atoi(buf2);

		else if (strcmp(buf, "L-CALC") == 0)
			l_calc = atoi(buf2);
		else if (strcmp(buf, "L") == 0)
			l_calc = atoi(buf2);

		else if (strcmp(buf, "M-CALC") == 0)
			m_calc = atoi(buf2);
		else if (strcmp(buf, "M") == 0)
			m_calc = atoi(buf2);

		else {  /* any other things */
			;
		}
		goto next_substring;

	}

	fclose(fp);

	return;
}


void short_form(form)
char *form;
{
	register char *cs;

	/* remove ' ', '\t', '\n' in name: before and after */
	cs = form;
	while ( *cs && (*cs == ' ' || *cs == '\t' || *cs == '\n')) {
		int i = 0;
		while ( (cs[i] = cs[i+1]) )  i++;
		/* if ( *cs ) cs++; */
	}
	cs = form + strlen(form) - 1;
	while ( *cs == ' ' || *cs == '\t' || *cs == '\n' )  cs--;
	cs++; *cs = '\0';

	/* remove double symbols ' ', '\t' in name */
	cs = form;
	while ( *cs ) {
	    if ((*cs==' ' || *cs=='\t') && (cs[1]==' ' || cs[1]=='\t')) {
		int i = 0;
		while ( (cs[i] = cs[i+1]) )  i++;
	    } else
		cs++;
	}
	return;
}

char *skip_wd(n, str, csq)
int n;
char *str, *csq;
{
	register char *cs, *rs, *fs;
	register int i;
	cs = str;
	for(i=0; i<n; i++) {
		if ( *cs == '\0' || *cs == '\n') {
			*csq = '\0';
			return cs;
		}
		/* miss emty fileds from beginnig */
		while (*cs == ' ' || *cs == '\t'||*cs == ';'||*cs == ',')
		      cs++;
		/* read till separator */
		while (*cs && *cs != ' ' && *cs != '\t' && *cs != '\n'
		   && *cs != ';' && *cs != ',')
		      cs++;
	}
	if ( *cs == '\0' || *cs == '\n') {
		*csq = '\0';
		return cs;
	}
	/* miss emty fields and separators after current field */
	while (*cs == ' ' || *cs == '\t' || *cs == ';'||*cs == ',')   cs++;
	if ( *cs == '\0' || *cs == '\n') {
		*csq = '\0';
		return cs;
	}
	rs = cs;
	fs = csq;
	while (*rs && *rs != ' ' && *rs != '\t' && *rs != '\n'
	      && *rs != ';' && *rs != ',') {
		*fs = *rs;
		fs++; rs++;
	}
	*fs = '\0';
	return cs;
}

/* transpose_map:           */
/* fi(na, nb) -> fi(nb, na) */
void transpose_map(f, na, nb)
double *f;      /* map f(na,nb): 1-dim array of 2-dim map */
int na, nb;
{
	register int i, j;
	int nn = na*nb;
	double *v;

	if ((v = (double *)calloc((unsigned)nn, sizeof *v)) == (double *)0) {
		PR(ER,"%s: no memory for temporal transposed array...\n",
			myname);
		exit(1);
	}
	for(i=0; i<na; i++) {
		register int k = i * nb;
		for(j=0; j<nb; j++) {
			 v[j*na+i] = f[k+j];
		}
	}
	for(i=0; i<nn; i++)  f[i] = v[i];

	free((void *)v);
	return;
}

#include <values.h>
int max_double_()
{
#ifndef MAXDOUBLE
#define MAXDOUBLE       MAXFLOAT
#endif
	return (int)(log10(MAXDOUBLE))-8;
}

int map_res_cmp(nx1,np1,nph1,nx2,np2, nph2)
int nx1, np1, *nph1;
int nx2, np2, *nph2;
{
    int flag=0;

    if (nx2 != nx1 || np2 != np1 || nph1[np1/2-1] != nph2[np1/2-1] ||
	nph1[1] != nph2[1] || nph1[2] != nph2[2])
	   flag = 1;

    return flag;
}
