#define  ON     1
#define  OFF    0
#define  DAY    86400.00
#ifndef  FMAX
#define  FMAX   1.e+30
#endif
#define  FZERO  1.e-30

#define TIMES(h, m, s) ((h)*3600.0 + (m)*60.0 + (s))
#define TIME(pix)      (crval1 + cdelt1 * ((double)(pix) - crpix1))
#define TIME1(pix)     (crval1 + cdelt1 * ((double)(pix) - crpix1))
#define TIME2(pix)     (crval2 + cdelt2 * ((double)(pix) - crpix2))
#define TIME3(pix)     (crval3 + cdelt3 * ((double)(pix) - crpix3))
#define TIME4(pix)     (crval4 + cdelt4 * ((double)(pix) - crpix4))

extern int    bitpix;
extern int    naxis;
extern long   naxis1;
extern double bscale;
extern double b_zero;
extern double cdelt1;
extern double crval1;
extern double crpix1;
extern double obsra, timeesh, timewsh;
extern char   ctype1[30];
extern char   bunit[30];
extern char   object[30];
extern char   rcv_mode[30];

#ifndef  FLOATPIX
#define BYTE     8
#define SHORT   16
#define LONG    32
#define FLOAT  (-32)
#define DOUBLE  64

#define BYTEPIX       8
#define SHORTPIX     16
#define LONGPIX      32
#define FLOATPIX   (-32)
#define DOUBLEPIX    64
#define COMPLEXSHORTPIX     33
#define COMPLEXLONGPIX      65
#define COMPLEXFLOATPIX   (-65)
#endif

#ifdef __GNUC__
extern float  get_pix(FILE *);
extern double get_pix_d(FILE *);
extern void  put_pix(FILE *, float), put_pix_d(FILE *, double),
	     out_pix(FILE *, int),   cop_pix(FILE *, FILE *);
#else
extern double  get_pix_d();
extern float   get_pix();
extern void    put_pix(), put_pix_d(), out_pix(), cop_pix();
#endif

/*
typedef enum {FALSE, TRUE} BOOLEAN;
  */
#define BOOLEAN int
#ifdef  FALSE
#undef  FALSE
#endif
#ifdef  TRUE
#undef  TRUE
#endif
#define FALSE   (0)
#define TRUE    (1)


#include <stdlib.h>
#include <sys/types.h>
#define BYTE 8

#define lowbyte(w) ((w) & 0377)
#define highbyte(w) lowbyte(((w)&0xff00 >> 8)

#define in_head(stream) Hinit(stream)
#define out_head(stream) Hupdate(stream)
#define head_length Hlen()

#if defined(__GNUC__)
extern int  Hinit(FILE *);      /* reads common F-file head */
extern int  Hupdate(FILE *);    /* output head of image */
#ifdef sun
/* extern int  Hupdate_key_off(__va_list); */
/* extern int  Hupdate_key_off(va_alist);  */
extern int  Hupdate_key_off();
#else
extern int  Hupdate_key_off(FILE *, char *, ...);
#endif
extern void dEVset(char *, double), eEVset(char *, double);
extern void Hfree(void);
extern BOOLEAN EVset(char *, char *), EVexport (char *);
extern void sEVset(char *, char *), fEVset(char *, float);
extern void iEVset(char *, int),    lEVset(char *, long);
extern void EVdel(char *), EVp_buf_size(int);
extern char   *EVget(char *);
extern BOOLEAN EVexport (char *);
extern void EVprint(void);

extern short  Hopen_(char *, char *);
extern void   Hclose_(void);
extern long   Hinit_(void), Hupdate_(void);
extern short  Check_key_(char *);
extern void   Ckey_get_(char *, char *);
extern short  Skey_get_(char *);
extern long   Lkey_get_(char *);
#if !defined (_WIN32)
extern void llEVset(char *, long long);
extern long long  LLkey_get_(char *);
extern void   LLkey_set_(char *, long long *);
#else
extern void llEVset(char *, long);
extern long  LLkey_get_(char *);
extern void  LLkey_set_(char *, long *);
#endif
extern float  Fkey_get_(char *);
extern double Dkey_get_(char *);
extern void   set_bit_(int *);
extern void   Ckey_set_(char *, char *);
extern void   Skey_set_(char *, short *);
extern void   Lkey_set_(char *, long *);
extern void   Fkey_set_(char *, float *);
extern void   Dkey_set_(char *, double *);
extern float  get_pix_ (void);
extern void   put_pix_ (float *);

#else
extern int Hinit();      /* reads common F-file head */
extern int Hupdate();    /* output head of image */
extern int Hupdate_key_off();
extern char *EVget();
extern BOOLEAN EVset(), EVexport ();
extern void EVprint();
extern int Hinit(), Hinit1();  /* reads common F-file head */
extern int Hupdate();          /* output head of image */
extern int Hlen();
extern void sEVset(), lEVset(), llEVset(), eEVset();
extern void fEVset(), dEVset(), iEVset();
extern void Hfree(), EVdel(), EVp_buf_size();

extern short  Hopen_();
extern void   Hclose_();
extern long   Hinit_(), Hupdate_();
extern short  Check_key_();
extern void   Ckey_get_();
extern short  Skey_get_();
extern long   Lkey_get_();
#if !defined (_WIN32)
extern long long  LLkey_get_();
#else
extern long   LLkey_get_();
#endif
extern float  Fkey_get_();
extern double Dkey_get_();
extern void   set_bit_ ();
extern void   Ckey_set_();
extern void   Skey_set_();
extern void   Lkey_set_();
extern void   Fkey_set_();
extern void   Dkey_set_();
extern float  get_pix_ ();
extern void   put_pix_ ();
#endif

#define Skey_set(key_name, value)  lEVset(key_name, (long)value); EVexport(key_name)
#define Lkey_set(key_name, value)  lEVset(key_name, (long)value); EVexport(key_name)
#if !defined (_WIN32)
#define LLkey_set(key_name,value)  llEVset(key_name, (long)value); EVexport(key_name)
#else
#define LLkey_set(key_name,value)  llEVset(key_name, (long long)value); EVexport(key_name)
#endif
#define Fkey_set(key_name, value)  fEVset(key_name, (float)value);  EVexport(key_name)
#define Ekey_set(key_name, value)  eEVset(key_name, (double)value); EVexport(key_name)
#define Dkey_set(key_name, value)  dEVset(key_name, (double)value); EVexport(key_name)
#define Ckey_set(key_name, value)  sEVset(key_name, value); EVexport(key_name)

#define Skey_get(key_name)  (short)atol(EVget(key_name))
#define Lkey_get(key_name)  atol(EVget(key_name))
#if !defined (_WIN32)
#define LLkey_get(key_name) atoll(EVget(key_name))
#else
#define LLkey_get(key_name) atol(EVget(key_name))
#endif
#define Fkey_get(key_name)  (float)atof(EVget(key_name))
#define Dkey_get(key_name)  atof(EVget(key_name))
#define Ckey_get(key_name)  EVget(key_name)

#ident  "#(@)ff.h, (C) O.Verkhodanov (SAO RAN), 10/05/1994"
#ifdef __GNUC__
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#else
extern double atof();
extern long atol();
extern int  atoi();
extern char *mktemp();
extern char *getenv();
#ifdef __STDC__
extern void *malloc(), *calloc();
#else
extern char *malloc(), *calloc();
#endif
#endif
#define SMIN (-32760.0)
#define SMAX ( 32760.0)


#define BORDER1(x)      ((x) < 0 ? -((int)(-(x))+1) : (int)(x))
#define BORDER2(x)      ((x) < 0 ? -(int)(-(x)) : (int)(x)+1)
#define ABS(x)          ((x) < 0 ? -(x) : (x))
#define SIGN(x)         ((x) < 0 ? -1 : 1)
#define HH(x)           ((int)((x)/3600.))
#define MM(x)           ((int)(((x) - HH(x)*3600.)/60.))
#define SS(x)           ((x) - HH(x)*3600. - MM(x)*60.)
#define DD(x)           ((int)(x))
#define MA(x)           ( (int)( ((x) - DD(x)) * 60.))
#define SA(x)           (( ((x) - DD(x)) * 60.- MA(x) ) * 60.)
#define SMALL           1.0e-12

#define  PRI(x)   fprintf(stderr,x)
#define  CLEAR    system("clear")
#define  FNULL    (float *)0
#define  FLNULL   (FILE *)0

#define  PR       fprintf
#define  ER       stderr
#define  U        unsigned

extern int sun_data_key;  /* to read data in inverse byte order  */

#if defined (__GNUC__)
extern void set_sig_fatal(void);
extern void fatal(char *), fatal2(char *, char *);
extern int  sig_tmp_save(char *);
extern void setopt(int, char **), usage(void);
#else
extern void set_sig_fatal();
extern void fatal(), fatal2();
extern int  sig_tmp_save();
extern void setopt(), usage();
#endif
