#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include "glesp.h"

#define PR  fprintf
#define ER  stderr

void gal2eq_map(f1, x1, nx1, np1, nph1, f2)
double *f1, *x1;
int nx1, np1;
int *nph1;
double *f2;
{
    register int i, j;
    int n;
    double alp, del;
    double p = 180./M_PI, dphi;

    /* get (alpha, delta) of pixel and      */
    /* find for it number of pixel in a map */
    for(i=0; i<nx1; i++) {
	    int ii = i * np1;
	    dphi = 2.*M_PI / nph1[i];
	    del = 90. - acos(x1[i]) * p;      /* delta in degs */
	    for(j=0; j<nph1[i]; j++) {
		  alp = j * dphi * p / 15.;   /* alpha in degs */
		  n = pix_eq2gal(alp,del, x1, nx1, np1, nph1);
		  f2[ii+j] = f1[n];
	    }
    }

    return;
}


void gal2ec_map(f1, x1, nx1, np1, nph1, f2)
double *f1, *x1;
int nx1, np1;
int *nph1;
double *f2;
{
    register int i, j;
    int n;
    double bet, lam;
    double p = 180./M_PI, dphi;
    extern int pix_ec2gal(double,double, double*, int, int, int *);

    /* get (betta, lambda) of pixel and     */
    /* find for it number of pixel in a map */
    for(i=0; i<nx1; i++) {
	    int ii = i * np1;
	    dphi = 2.*M_PI / nph1[i];
	    bet = 90. - acos(x1[i]) * p;      /* ecl. betta  in degs */
	    for(j=0; j<nph1[i]; j++) {
		  lam = j * dphi * p;         /* ecl. lambda in degs */
		  n = pix_ec2gal(bet,lam, x1, nx1, np1, nph1);
		  f2[ii+j] = f1[n];
	    }
    }

    return;
}


