#include <stdio.h>
#include <stdlib.h>
#include <stddef.h>

#include "gd.h"

void get_gifim (x, nx, ny, r, g, b, nc, filename)
int *x;
int *nx, *ny, *nc;
int *r, *g, *b;
char *filename;
{
    register int i, j;
    FILE  *fp;
    gdImagePtr image;

    /* read gif image from file */
    if ((fp = fopen(filename, "rb")) == (FILE *)0) {
	fprintf(stderr, "get_gifarr: can not open file '%s'\n", filename);
	exit(1);
    }
    image = gdImageCreateFromGif(fp);
    fclose(fp);

    /* read color table */
    for (i = 0; i < *nc; i++) {
	r[i] = gdImageRed(image, i);
	g[i] = gdImageGreen(image, i);
	b[i] = gdImageBlue(image, i);
    }

    for (j = 0; j < *ny; j++) {
	int jj = j * *nx;
	for (i = 0; i < *nx; i++) {
	    x[i+jj] = gdImageGetPixel(image, i, j);
	}
    }

    /* destroy image */
    gdImageDestroy(image);

    return;
}
