#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "gd.h"
#include "gdfontt.h"
#include "gdfonts.h"
#include "gdfontmb.h"
#include "gdfontl.h"
#include "gdfontg.h"

# define PR     fprintf
# define ER     stderr

void str2gif (x, nx, ny, sx, sy, nc, r, g, b, str, flag, font_size)
int *x, *nx, *ny;
int *sx, *sy;
int *nc, *r, *g, *b;
char *str;
int *flag, *font_size;
{
    register int i,j,c;
    gdImagePtr image;
    gdFontPtr  ft = gdFontMediumBold;
    int xs, ys;
    int *color_table;

    /* select font size according to image size */
    switch (*font_size) {
    case  1 :
    case 'T':
	ft = gdFontTiny;
	break;
    case  2 :
    case 'S':
	ft = gdFontSmall;
	break;
    case  3 :
    case 'M':
	ft = gdFontMediumBold;
	break;
    case  4 :
    case 'L':
	ft = gdFontLarge;
	break;
    case  5 :
    case 'G':
	ft = gdFontGiant;
	break;
    case  0 :
	if (*nx < 300) {
	    ft = gdFontTiny;
	} else if (*nx < 600) {
	    ft = gdFontSmall;
	} else if (*nx < 900) {
	    ft = gdFontMediumBold;
	} else if (*nx < 1200) {
	    ft = gdFontLarge;
	} else {
	    ft = gdFontGiant;
	}
	break;
    }

    /* create a new image with appropriate dimensions */
    image = gdImageCreate(*nx, *ny);

    /* allocate color table */
    color_table = (int *)malloc(*nc*sizeof(int));
    for (i = 0; i < *nc; i++)
	color_table[i] = gdImageColorAllocate(image, r[i], g[i], b[i]);

    /* set pixel colors in image */
    for (j = 0; j < *ny; j++) {
	int jj = j * *nx;
	for (i = 0; i < *nx; i++) {
	    c = x[i + jj];
	    gdImageSetPixel(image, i, j, color_table[c]);
	}
    }

    ys = *sy - ft->h / 2;
    if (*flag < 0) {
	xs = *sx - ((strlen(str) + 1) * ft->w);
    } else if (*flag > 0) {
	xs = *sx + ft->w;
    } else {
	xs = *sx - (strlen(str) * ft->w / 2);
    }

    gdImageString(image, ft, xs, ys, str, color_table[0]);

    for (j = 0; j < *ny; j++) {
	int jj = j * *nx;
	for (i = 0; i < *nx; i++) {
	    x[i + jj] = gdImageGetPixel(image, i, j);
	}
    }

    /* destroy image */
    gdImageDestroy(image);

    return;
}
