#include "gd.h"
#include <stdio.h>
#include <stdlib.h>

void write_image (x, nx, ny, r,g,b, nc, filename)
int *x, *nx, *ny, *nc;
int *r, *g, *b;
char *filename;
{
    register int  i,j,c;
    gdImagePtr image;
    FILE  *fp_out;
    int   *color_table;

    /* create a new image with appropriate dimensions */
    image = gdImageCreate(*nx, *ny);

    /* allocate color table */
    color_table = (int *)malloc(*nc*sizeof(int));
    for (i = 0; i < *nc; i++) {
      color_table[i] = gdImageColorAllocate(image, r[i], g[i], b[i]);
    }

    /* set pixel colors in image */
    for (j = 0; j < *ny; j++) {
	int jj = j * *nx;
	for (i = 0; i < *nx; i++) {
	    c = x[i + jj];
	    gdImageSetPixel(image, i, j, color_table[c]);
	}
    }

    /* write image to gif file */
    if((fp_out = fopen(filename, "wb")) == (FILE *)0) {
	fprintf(stderr, "write_image: can not create output file '%s'\n",
	    filename);
	exit(1);
    }
    gdImageGif(image, fp_out);
    fclose(fp_out);

    /* destroy image */
    gdImageDestroy(image);

    return;
}
