        SUBROUTINE lgndr_M(Lmx,m,cmm,c,x,glm)
C   Legendre functions F^m_k(x), k=m,m+1,...,Kmx
      IMPLICIT REAL*8(a-h,o-y)
      DIMENSION glm(Lmx+1),c(2*Lmx+1)
c   Lim=Log(eps)< 0, ~ -20

            Lmin=300            ! must be corrected
	    dfm=0.5d0*m*dlog10(1.d0-x*x+1.d-50)
            Imax=0
            Enorm=1.d+01**Lmin  ! 10**Lmin
	    if(dabs(dfm).gt.Lmin) Imax=-dfm/Lmin
ccc   if(x.lt.-0.9990.and.x.gt.-0.9991.and.m.eq.2) then
ccc   v1=1.d0-x*x
ccc   v2=v1+1.d-50
ccc   print *, 'v=',v1,v2
ccc   print *, 'x=',x,x*x,1.d0-x*x+1.d-50
ccc   endif
	    dfm=dfm+Imax*Lmin

	    glm(m+1)=cmm*1.d+01**dfm       ! P_m^m
ccc   if(x.lt.-0.9990.and.x.gt.-0.9991.and.m.eq.2) then
ccc   print *, cmm,dfm,1.d+01**dfm
ccc   endif
	    if(m.eq.Lmx) then
180             continue
		if(Imax.gt.0) then
		      glm(m+1)=glm(m+1)/Enorm
		      Imax = Imax-1
		      if(Imax.gt.0) goto 180
		endif
		return
	    endif

	    glm(m+2)=x*c(m+1)*glm(m+1)     ! P_m+1^m
	    if(m+1.eq.Lmx) then
181             continue
		if(Imax.gt.0) then
		      glm(m+1)=glm(m+1)/Enorm
		      glm(m+2)=glm(m+2)/Enorm
		      Imax = Imax-1
		      if(Imax.gt.0) goto 181
		endif
		return
	    endif

ccc   if(x.lt.-0.9990.and.x.gt.-0.9991.and.m.eq.2) then
ccc   print *, glm(m+1),glm(m+2),c(m+1),x
ccc   endif
	    DO k=m+2,Lmx                   ! P_m+l^m
              glm(k+1)=x*c(k)*glm(k)-c(Lmx+k)*glm(k-1)
		IF(dabs(glm(k+1)).gt.Enorm) THEN
                   do kk=m+1,k+1
                     glm(kk)=glm(kk)/Enorm
                     if(Imax.ge.2) glm(kk)=glm(kk)/Enorm
                   enddo
                     if(Imax.ge.2) then
                        Imax=Imax-2
                     else
                        Imax=Imax-1
                     endif
                ENDIF
            ENDDO
            IF(Imax.ge.1) THEN
              do i=1,Imax
              do kk=m+1,Lmx+1
                 glm(kk)=glm(kk)/Enorm
              enddo
              enddo
            ENDIF
        return
        end     
C-----------------------------------------------------------
        SUBROUTINE start_clm(Lmx,m,cmm,c)
        IMPLICIT REAL*8(a-h,o-y)
        dimension c(2*Lmx+1)
c       preparation of coefficients for recurrent 
c       relation for P_l^m
         cmm=.5D0
        if(m.gt.0) then
         DO k=2,2*m,2
            cmm=cmm*(k+1.)/k
         ENDDO
        endif
         cmm=(1-2*mod(m,2))*dsqrt(cmm)

         k=m+1
         c(k)=dsqrt((4*k*k-1.d0)/(k*k-m*m))
         c(Lmx+k)=0.
         if(m.eq.Lmx) return
	 m2 = m*m
	 DO k=m+2,Lmx
	    k2 = k*k
	    c(k)=dsqrt((4.*k2-1.d0)/(k2-m2))
            c(Lmx+k)=dsqrt((2.*k+1.d0)*((k-1.)*(k-1.)
     +                  -m2)/(2.*k-3.)/(k2-m2))
         ENDDO
        return
        END
C-----------------------------------------------------------
        SUBROUTINE lgndr_0(Lmx,x,glm0)
C   Legandr polinomus F^0_l(x) 
      IMPLICIT REAL*8(a-h,o-y)
      DIMENSION glm0(2*Lmx+1)

        x2=x*x
        glm0(Lmx+1)=dsqrt(0.5d0)                !P_0
        glm0(Lmx+2)=dsqrt(1.5d0)*x              !P_1
        glm0(Lmx+3)=dsqrt(2.5d0)*(1.5d0*x2-0.5d0) !P_2
        if(Lmx.eq.2) return
        glm0(Lmx+4)=dsqrt(3.5d0)*x*(2.5d0*x2-1.5d0) !P_3
        if(Lmx.eq.3) return
        DO i=4,Lmx      
           eps=1.-1./(i+0.)             ! i=l
           eps1=i+0.5d0 
           eps2=dsqrt(eps1/(eps1-1.))           !       
           eps1=dsqrt(eps1/(eps1-2.))           !       
           j=Lmx+i+1    
           glm0(j)=x*(1.+eps)*eps2*glm0(j-1)-
     +             eps*eps1*glm0(j-2)
        ENDDO

        return
        end
C-----------------------------------------------------------
        function F_mm(m,x)
        IMPLICIT REAL*8(a-h,o-y)
c       Legandr function F_m^m 
         cmm=.5D0
         DO k=2,2*m,2
            cmm=cmm*(k+1.d0)/k
         ENDDO
         cmm=(1-2*mod(m,2))*dsqrt(cmm)

         xs=dsqrt(1.d0-x*x)
         F_mm=cmm*xs**m
          return
        END
C-----------------------------------------------------------
        SUBROUTINE tridag(abc,u,n,r1,rn)
        IMPLICIT REAL*8(a-h,o-y)
        dimension abc(4*n),u(n)
ccc    gam=abc(1:n),a=abc(n+1:2n),b=abc(2n+1:3n),c=abc(3n+1:4n)

        na=n
        nb=n+n
        nc=n+n+n
        if(abc(nb+1).eq.0.)pause 'tridag: rewrite equations'
        bet=abc(nb+1)
        u(1)=r1/bet
        do 11 j=2,n
          abc(j)=abc(nc+j-1)/bet
          bet=abc(nb+j)-abc(na+j)*abc(j)
          if(bet.eq.0.)pause 'tridag failed'
          u(j)=-abc(na+j)*u(j-1)/bet
11      continue
        u(n)=(rn-abc(na+n)*u(n-1))/bet
        do 12 j=n-1,1,-1
          u(j)=u(j)-abc(j+1)*u(j+1)
12      continue

        return
        END
C-----------------------------------------------------------
        SUBROUTINE lgndr_L(Lmx,L,x,abc,glm)
C   Legandr functions F^m_L(x), m=1,2,...,L 
      IMPLICIT REAL*8(a-h,o-y)
      DIMENSION glm(2*Lmx+1),abc(4*Lmx)

        IF(L.eq.2) then
           glm(1)=-dsqrt(3.75d0)*x*dsqrt(1.d0-x*x)
           glm(2)=dsqrt(0.9375d0)*(1.-x*x)
           return
        ENDIF

        IF(L.gt.2) THEN
        n=L-1
        nb=2*n
        nc=3*n
        xs=2.*x/dsqrt(1.d0-x*x)
C     abc(n+i)=a,abc(2n+i)=b,abc(3n+i)=c,
C   parameters of the matrix
        r1=-glm(Lmx+L+1)/dsqrt((1.-1./L)*(1.+1./(1.+L)))
        rf=-F_mm(L,x)
        abc(n+1)=0                      ! a(1)=0
        abc(nb+1)=xs/dsqrt(L*L+L-2.)    ! b(1)=0
        abc(nc+1)=1.                    ! c(1)=1
        do m=1,n-1
           e1=dsqrt((L-m-1.)*(L+m+2.) )
           abc(n+m+1)=dsqrt((L-m)*(L+m+1.))/e1  ! a(m)
           abc(nb+m+1)=xs*(m+1.)/e1             ! b(m)
           abc(nc+m+1)=1.                       ! c(m)=1
        enddo
        abc(nc+n)=0                             ! c(L)=0
        
        call tridag(abc,glm,n,r1,rf)
        glm(L)=-rf

        ENDIF
        return
        end
C-----------------------------------------------------------
        
