#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>

#include "glesp.h"

#define PR      fprintf
#define ER      stderr

extern char *myname;

void map_alisa(f, x, nx, np, nph, inp_file, event_num, event_type, event_inf)
double *f;
double *x;
int nx, np, *nph;
char *inp_file;
int event_num;  /* select event with corresponding number    */
int event_type; /* select corr. type event: 1-prim., 0-2nd., >100 - counts */
int event_inf;  /* flag for event on infinity                */
{
    FILE *fp;
    char str[161];
    double theta, eta, phi, delta_eta, delta_theta, delta_phi;
    int flag, nn;
    double rad2deg = 180. / M_PI;
    int n_event = event_num;
    int flag_1 = event_inf, flag_n = 0;
    int flag_count = 0;

    if (event_type > 100) {
	flag_count = 1;     /* count number of pixels */
	event_type -= 1000;
    }

    if (flag_1 < 0)  flag_1 = 0;

    /* open input file with Alisa data */
    if ((fp = fopen(inp_file, "r")) == (FILE *)0) {
	PR(ER, "%s: can not open file '%s'.\n", myname, inp_file);
	exit(1);
    }

    while(fgets(str,160,fp) != NULL) {
	if (*str == '#' || *str == '\n')
	    continue;
	if (strncmp("BEGIN", str, 5) == 0) {
	    char ss[161];
	    if ( n_event > 0) {
		sscanf(str, "%s%s%d",ss,ss,&nn);
		if (n_event == nn)   flag_n = 1;
	    }
	    continue;
	}
	if (strncmp("END", str, 3) == 0) {
	    if (flag_n)  flag_n = 0;
	    continue;
	}

	if (n_event < 0 || (n_event > 0 && flag_n)) {
	    double v=0.0;
	    int n_pix;
//            sscanf(str, "%lf%lf%d%lf%lf",
//                &eta, &phi, &flag, &delta_eta, &delta_phi);
//            sscanf(str, "%lf%lf%lf%d%lf%lf",
//                &eta, &phi, &theta, &flag, &delta_eta, &delta_phi);

	    if (flag_count)
		sscanf(str, "%lf%lf%lf%d%lf%lf",
		    &eta, &theta, &phi, &flag, &delta_eta, &delta_phi);
	    else
		sscanf(str, "%lf%lf%lf%lf",
		    &eta, &theta, &phi, &v);

	    theta /= rad2deg;
	    phi   /= rad2deg;

	    if (flag_count) {
		 /* type event: 1-prim., 0-2nd. flag - event type in str */
//              if (event_type >=0)
//                    if (event_type != flag)
//                        continue;
		/* flag_1 = event_inf or =0 */
		if (flag_1 && delta_eta < 0.)
			continue;

//              theta = 2. * atan (exp(-eta));
		delta_theta = fabs(-2 * delta_eta / (exp (-eta) + exp (eta)));
		delta_phi /= rad2deg;
//              printf("%10gd %10gd 1\n", theta*rad2deg, phi*rad2deg);
	    }
	    n_pix = ang2n(theta, phi, x, nx, np, nph);

	    if (flag_count)
		f[n_pix] += 1; /* counter: sum of events */
	    else
		f[n_pix] += v; /* sum of event values */
	}
    }

    fclose (fp);
    return;
}
