# include <stdio.h>
# include <stdlib.h>
# include <unistd.h>
# include <strings.h>
# include <math.h>

# include "glesp.h"

#define PR      fprintf
#define ER      stderr

/*
 *  create isolines
 *      Oleg Verkhodanov,
 *      22/03/2006
 */
extern char *myname;

void map_isol(f, nx, np, nph, isol_array, isol_n)
double *f;
int nx, np, *nph;
double isol_array;
double isol_n;
{
    register int i, j, is;
    register int *b1 = (double *)0,
		 *b2 = (double *)0;

    if ((b1=(int*)calloc((unsigned)(nx*np), sizeof *b1)) == (int *)0) {
nomem:
	PR(ER, "%s: no memory for temporal array\n", myname);
	exit(1);
    }
    if ((b2=(int*)calloc((unsigned)(nx*np), sizeof *b2)) == (int *)0)
	goto nomem;

    for(is=0; is<isol_n; is++) {
	/* set select zone */
	for(i=0; i<nx; i++) {
	    register int ii = i * np;
	    for(j=0; j<nph[i]; j++) {
		if ( f[ii+j] > isol_array[is] )  b1[ii+j] = 1;
	    }
	}
	/* set zone limit - transform to isoline */
	for(i=0; i<nx; i++) {
	    register int ii = i * np;
	    b1[ii] = b1[ii] - b1[nph[i]-1];
	    for(j=1; j<nph[i]; j++)  b1[ii+j] = b1[ii+j] - b1[ii+j-1];
	}

	/* keep in memory current isoline */
	for(i=0; i<nx; i++) {
	    register int ii = i * np;
	    for(j=1; j<nph[i]; j++)  {
		if (b1[ii+j] != 0)  b2[ii+j] = is;
	    }
	}

	/* set zero */
	for(i=0; i<nx; i++) {
	    register int ii = i * np;
	    for(j=0; j<nph[i]; j++)  b1[ii+j] = 0;
	}
    }

    /* set these isolines in input arrays */
    for(i=0; i<nx; i++) {
	register int ii = i * np;
	for(j=0; j<nph[i]; j++)  f1[ii+j] = b2[ii+j];
    }

    if (*b1 != (int *)0)  free((void *)b1);
    if (*b2 != (int *)0)  free((void *)b2);
    return;
}
