#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>

#include "glesp.h"

#define PR      fprintf
#define ER      stderr

extern int math_calc_pr(char *, double *);

int  map_formu(f, x, nx, np, nph, fstr)
double *f, *x;
int nx, np, *nph;
char *fstr;
{
    register int i, j;
    char str[555];
    double pi2 = M_PI * 2., v;

    for(i=0; i<nx; i++) {
	int ii = i * np;
	double t = acos(x[i]), dp = pi2 / nph[i];
	for(j=0; j<np; j++) {
	    double p = j * dp;
	    sprintf(str, "x=%12.5e;p=%12.5e;phi=p;t=%12.5e;theta=t;%s",
		   x[i], p, t, fstr);
	    if (math_calc_pr(str, &v) < 0) {
		   return -1;
	    }
	    f[ii+j] = v;
	}
    }

    return 1;
}

extern double calc_val(double, double, double);
extern int start_calc(char *);

int  map_formu1(f, x, nx, np, nph, fstr)
double *f, *x;
int nx, np, *nph;
char *fstr;
{
    register int i, j;
    char str[555];
    double pi2 = M_PI * 2., v;

    sprintf(str, "x=0.0; t=0.0; p=0.0; %s",  fstr);
    start_calc(str);

    for(i=0; i<nx; i++) {
	int ii = i * np;
	double t = acos(x[i]), dp = pi2 / nph[i];
	for(j=0; j<np; j++) {
	    double p = j * dp;
	    v = calc_val(x[i],t,p);
	    f[ii+j] = v;
	}
    }

    return 1;
}
