#if __GNUC__
#include <stdlib.h>
#endif
#include <stdio.h>
#include <math.h>
#include <string.h>
#include <ctype.h>

#ifdef MSDOS
        typedef  int void;
#else
#       include <signal.h>
#endif

/*
 *   a part of CALC from Garry Perlman
 *   modified a little by Oleg Verkhodanov, SAO, Russia
 *   and called with  math_calc_pr()
 */
#define PR  fprintf
#define ER  stderr
extern char *myname;
static char math_string[555];
extern int vkey;


#define YYBYACC 1
/*  Copyright 1981 Gary Perlman */

#ifdef MSDOS /* increase stack size on MSODS */
int  _stack = 32000;
#endif

#define CALC_VERSION                   "5.2 11/2/85"
/* PGM(calc, Algebraic Modeling Calculator) */

#define FZERO         (10e-20)
#define fzero(x)      (fabs (x) < FZERO)
#define isvarchar(c)  (isalnum ((int)c) || (c) == '_')

#ifndef iscntrl
#define iscntrl(a) ((a)>0&&(a)<26)
#endif
#define OPERATOR     1
#define PARSERROR    1
#define MAXVAR    1000 
#define UNDEFINED   -99999999999.987654321
int     Nvar;
char    *Varname[MAXVAR];
char    *Eptr;
int     Printequation = 0;
char    *Prompt = "CALC: ";
int     Interactive = 0;
char    Format[100] = "%.10g";    /* default print format for numbers */

typedef union
{
        int     opr;        /* if OPERATOR */
        double  *num;       /* if NUMBER */
        int     var;        /* if VARIABLE */
} STUFF;
STUFF   Tmp1, Tmp2;  /* used in the parser to cast operators */
typedef struct enode {       /* expression node in tree */
        int     etype;          /* type of node */
        STUFF   contents;
        struct  enode *left;
        struct  enode *right;
} ENODE;
#define ENULL ((ENODE *) NULL)
ENODE   *Expression, *Variable[MAXVAR];

double  Answer;
double  *Constant;
FILE    *Outfile;
typedef union
{
        int     opr;   /* an operator */
        int     var;   /* an index into the variable table */
        double  *num;  /* a pointer to a numerical constant */
        ENODE   *ex;   /* an expression in the parse tree */
} YYSTYPE;
#define YYERRCODE 256
#define NUMBER 257
#define VARIABLE 258
#define IF 259
#define THEN 260
#define ELSE 261
#define EQ 262
#define NE 263
#define GE 264
#define LE 265
#define UMINUS 266
#define ABS 267
#define EXP 268
#define LOG 269
#define LOG10 270
#define SQRT 271
#define COS 272
#define TAN 273
#define SIN 274
#define ACOS 275
#define ASIN 276
#define ATAN 277
#define FLOOR 278
#define CEIL 279
#define INT 280
#define LOG2 281
#define SINH 282
#define COSH 283
#define ASINH 284
#define ACOSH 285
short yylhs[] = {                                        -1,
    0,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,
};
short yylen[] = {                                         2,
    1,    3,    3,    2,    3,    3,    3,    3,    3,    3,
    2,    3,    3,    3,    3,    3,    3,    3,    3,    2,
    5,    4,    3,    2,    2,    2,    2,    2,    2,    2,
    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
    2,    2,    1,    1,
};
short yydefred[] = {                                      0,
   44,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   11,   33,   32,   30,   31,   34,   27,   29,
   28,   24,   25,   26,   37,   36,   35,   38,   39,   40,
   41,   42,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    2,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,
};
short yydgoto[] = {                                      27,
   28,
};
short yysindex[] = {                                    199,
    0,  -61,  199,  199,  199,  199,  199,  199,  199,  199,
  199,  199,  199,  199,  199,  199,  199,  199,  199,  199,
  199,  199,  199,  199,  199,  199,    0,  460,  199,  460,
  339,  526,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  368,  199,  199,  199,  199,  199,  199,  199,
  199,  199,  199,  199,  199,  199,  199,  199,  199,  460,
  199,    0,  448,  498,  514,  526,  -27,  -27,  -27,  -27,
  -27,  -27,  -20,  -20,  -92,  -92,  -92,  -92,  487,  199,
  498,
};
short yyrindex[] = {                                      0,
    0,    1,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    3,    0,    8,
    0,   91,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   12,
    0,    0,    0,   21,  182,  143,  147,  156,  162,  166,
  175,  189,  107,  133,   13,   40,   68,   97,  253,    0,
   31,
};
short yygindex[] = {                                      0,
  636,
};
#define YYTABLESIZE 791
short yytable[] = {                                      29,
   43,   69,    1,    0,    0,    0,    0,    4,    0,   68,
    0,    3,    7,    0,   66,   64,   68,   65,    0,   67,
   23,   66,    0,    0,    0,    0,   67,    0,    0,    0,
   21,    0,    0,    0,    0,    0,    0,   43,   43,    9,
    0,   43,   43,   43,    0,   43,    0,   43,    4,    7,
    7,    0,    3,    7,    7,    7,    0,    7,   43,    7,
   43,   23,   43,   43,    0,    4,   69,    8,    0,    3,
    7,   21,    7,   69,    7,    7,    9,    9,   23,    0,
    9,    9,    9,   23,    9,    0,    9,    0,   21,    0,
   20,    0,    0,   21,   43,    0,   10,    9,    0,    9,
    0,    9,    9,    0,    8,    8,    5,    0,    8,    8,
    8,    0,    8,    0,    8,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   43,    8,    0,    8,   20,    8,
    8,   20,    6,   10,   10,    0,    7,   10,   10,   10,
    0,   10,   18,   10,    5,    0,   12,    5,   20,    5,
    0,    5,    0,   20,   10,   13,   10,    0,   10,   10,
    0,   16,    0,    9,    5,   14,    5,    0,    5,    5,
    6,    0,    0,    6,   15,    6,    0,    6,    0,    0,
   18,   19,    0,   18,   12,    0,    0,   12,   17,    0,
    6,    8,    6,   13,    6,    6,   13,    0,    0,   16,
   18,    0,   16,   14,   12,   18,   14,    0,    0,   12,
    0,    0,   15,   13,   20,   15,    0,    0,   13,   16,
   10,    0,   19,   14,   16,    0,   17,    0,   14,   17,
    5,    5,   15,    3,    0,    0,    0,   15,   26,   19,
    0,    0,    0,    6,   19,    0,   17,    0,    0,    0,
    0,   17,   22,    0,    0,    0,    6,    0,    0,    0,
   43,   43,   43,   43,   43,   43,   18,    4,    0,    0,
   12,    3,    7,    7,    7,    7,    7,    7,    0,   13,
   23,   23,    0,    0,    0,   16,    0,    0,    0,   14,
   21,   21,    0,   22,    0,    0,    0,    0,   15,    9,
    9,    9,    9,    9,    9,   19,    0,    0,    0,    0,
   22,    0,   17,    0,    0,   22,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    8,    8,    8,
    8,    8,    8,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   20,   20,    0,    0,    0,    0,   10,   10,   10,   10,
   10,   10,    0,    0,    0,    0,    5,    5,    5,    5,
    5,    5,    0,    0,    0,   68,   57,    0,    0,    0,
   66,   64,    0,   65,    0,   67,    0,    0,    0,    0,
    0,    0,    6,    6,    6,    6,    6,    6,   62,    0,
   63,   54,   18,   18,   68,   57,   12,   12,   72,   66,
   64,    0,   65,    0,   67,   13,   13,    0,    0,    0,
    0,   16,   16,    0,    0,   14,   14,   62,    0,   63,
   54,    0,   69,    0,   15,   15,    0,    0,    0,    0,
    0,   19,   19,    0,    0,    0,    0,    0,   17,   17,
    0,    0,    0,    0,    0,    1,    2,    4,    0,    0,
    0,   69,   56,    0,    0,    7,    8,    9,   10,   11,
   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,
   22,   23,   24,   25,   68,   57,    0,    0,    0,   66,
   64,   56,   65,    0,   67,    0,   68,   57,    0,    0,
    0,   66,   64,    0,   65,   90,   67,   62,    0,   63,
   54,    0,   22,    0,    0,    0,    0,    0,    0,   62,
    0,   63,   54,   68,   57,    0,    0,    0,   66,   64,
    0,   65,    0,   67,   68,   57,    0,    0,    0,   66,
   64,   69,   65,    0,   67,    0,   62,    0,   63,    0,
   68,   57,    0,   69,    0,   66,   64,   62,   65,   63,
   67,    0,   68,    0,    0,    0,    0,   66,   64,    0,
   65,   56,   67,   62,    0,   63,    0,    0,    0,    0,
   69,    0,    0,   56,    0,   62,    0,   63,    0,    0,
    0,   69,    0,    0,    0,    0,    0,    0,   71,   55,
   58,   59,   60,   61,    0,    0,    0,   69,    0,    0,
   56,    0,    0,    0,    0,    0,    0,    0,    0,   69,
    0,   56,    0,    0,    0,    0,    0,    0,   55,   58,
   59,   60,   61,    0,    0,    0,    0,    0,   30,   31,
   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,
   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,
   52,   53,    0,    0,   70,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   73,
   74,   75,   76,   77,   78,   79,   80,   81,   82,   83,
   84,   85,   86,   87,   88,    0,   89,    0,   55,   58,
   59,   60,   61,    0,    0,    0,    0,    0,    0,    0,
   55,   58,   59,   60,   61,   91,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   55,   58,   59,
   60,   61,    0,    0,    0,    0,    0,    0,    0,   58,
   59,   60,   61,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   58,   59,   60,   61,    0,
    0,    0,    0,    0,    0,    0,    0,   58,   59,   60,
   61,
};
short yycheck[] = {                                      61,
    0,   94,    0,   -1,   -1,   -1,   -1,    0,   -1,   37,
   -1,    0,    0,   -1,   42,   43,   37,   45,   -1,   47,
    0,   42,   -1,   -1,   -1,   -1,   47,   -1,   -1,   -1,
    0,   -1,   -1,   -1,   -1,   -1,   -1,   37,   38,    0,
   -1,   41,   42,   43,   -1,   45,   -1,   47,   41,   37,
   38,   -1,   41,   41,   42,   43,   -1,   45,   58,   47,
   60,   41,   62,   63,   -1,   58,   94,    0,   -1,   58,
   58,   41,   60,   94,   62,   63,   37,   38,   58,   -1,
   41,   42,   43,   63,   45,   -1,   47,   -1,   58,   -1,
    0,   -1,   -1,   63,   94,   -1,    0,   58,   -1,   60,
   -1,   62,   63,   -1,   37,   38,    0,   -1,   41,   42,
   43,   -1,   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  124,   58,   -1,   60,   38,   62,
   63,   41,    0,   37,   38,   -1,  124,   41,   42,   43,
   -1,   45,    0,   47,   38,   -1,    0,   41,   58,   43,
   -1,   45,   -1,   63,   58,    0,   60,   -1,   62,   63,
   -1,    0,   -1,  124,   58,    0,   60,   -1,   62,   63,
   38,   -1,   -1,   41,    0,   43,   -1,   45,   -1,   -1,
   38,    0,   -1,   41,   38,   -1,   -1,   41,    0,   -1,
   58,  124,   60,   38,   62,   63,   41,   -1,   -1,   38,
   58,   -1,   41,   38,   58,   63,   41,   -1,   -1,   63,
   -1,   -1,   38,   58,  124,   41,   -1,   -1,   63,   58,
  124,   -1,   41,   58,   63,   -1,   38,   -1,   63,   41,
  124,   33,   58,   35,   -1,   -1,   -1,   63,   40,   58,
   -1,   -1,   -1,   45,   63,   -1,   58,   -1,   -1,   -1,
   -1,   63,    0,   -1,   -1,   -1,  124,   -1,   -1,   -1,
  260,  261,  262,  263,  264,  265,  124,  260,   -1,   -1,
  124,  260,  260,  261,  262,  263,  264,  265,   -1,  124,
  260,  261,   -1,   -1,   -1,  124,   -1,   -1,   -1,  124,
  260,  261,   -1,   41,   -1,   -1,   -1,   -1,  124,  260,
  261,  262,  263,  264,  265,  124,   -1,   -1,   -1,   -1,
   58,   -1,  124,   -1,   -1,   63,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  260,  261,  262,
  263,  264,  265,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  260,  261,   -1,   -1,   -1,   -1,  260,  261,  262,  263,
  264,  265,   -1,   -1,   -1,   -1,  260,  261,  262,  263,
  264,  265,   -1,   -1,   -1,   37,   38,   -1,   -1,   -1,
   42,   43,   -1,   45,   -1,   47,   -1,   -1,   -1,   -1,
   -1,   -1,  260,  261,  262,  263,  264,  265,   60,   -1,
   62,   63,  260,  261,   37,   38,  260,  261,   41,   42,
   43,   -1,   45,   -1,   47,  260,  261,   -1,   -1,   -1,
   -1,  260,  261,   -1,   -1,  260,  261,   60,   -1,   62,
   63,   -1,   94,   -1,  260,  261,   -1,   -1,   -1,   -1,
   -1,  260,  261,   -1,   -1,   -1,   -1,   -1,  260,  261,
   -1,   -1,   -1,   -1,   -1,  257,  258,  259,   -1,   -1,
   -1,   94,  124,   -1,   -1,  267,  268,  269,  270,  271,
  272,  273,  274,  275,  276,  277,  278,  279,  280,  281,
  282,  283,  284,  285,   37,   38,   -1,   -1,   -1,   42,
   43,  124,   45,   -1,   47,   -1,   37,   38,   -1,   -1,
   -1,   42,   43,   -1,   45,   58,   47,   60,   -1,   62,
   63,   -1,  260,   -1,   -1,   -1,   -1,   -1,   -1,   60,
   -1,   62,   63,   37,   38,   -1,   -1,   -1,   42,   43,
   -1,   45,   -1,   47,   37,   38,   -1,   -1,   -1,   42,
   43,   94,   45,   -1,   47,   -1,   60,   -1,   62,   -1,
   37,   38,   -1,   94,   -1,   42,   43,   60,   45,   62,
   47,   -1,   37,   -1,   -1,   -1,   -1,   42,   43,   -1,
   45,  124,   47,   60,   -1,   62,   -1,   -1,   -1,   -1,
   94,   -1,   -1,  124,   -1,   60,   -1,   62,   -1,   -1,
   -1,   94,   -1,   -1,   -1,   -1,   -1,   -1,  260,  261,
  262,  263,  264,  265,   -1,   -1,   -1,   94,   -1,   -1,
  124,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   94,
   -1,  124,   -1,   -1,   -1,   -1,   -1,   -1,  261,  262,
  263,  264,  265,   -1,   -1,   -1,   -1,   -1,    3,    4,
    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,
   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,
   25,   26,   -1,   -1,   29,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   54,
   55,   56,   57,   58,   59,   60,   61,   62,   63,   64,
   65,   66,   67,   68,   69,   -1,   71,   -1,  261,  262,
  263,  264,  265,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  261,  262,  263,  264,  265,   90,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  261,  262,  263,
  264,  265,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  262,
  263,  264,  265,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  262,  263,  264,  265,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  262,  263,  264,
  265,
};
#define YYFINAL 27
#define YYMAXTOKEN 285
#define yyclearin (yychar=(-1))
#define yyerrok (yyerrflag=0)
#ifdef YYSTACKSIZE
#ifndef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#endif
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 10000
#define YYMAXDEPTH 10000
#endif
#endif
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short yyss[YYSTACKSIZE];
YYSTYPE yyvs[YYSTACKSIZE];
#define yystacksize YYSTACKSIZE

/*
 *   descriptions of functions
 *   by Oleg Verkhodanov, SAO, Russia
 */
#ifdef __GNUC__
extern int    yylex (void);
extern void   yyerror (char *);
extern ENODE *node(STUFF *, int, ENODE *, ENODE *);
extern int    math_calc_pr(char *, double *);
extern double eval (ENODE *);
extern void   ptree (FILE *, ENODE *);
extern int    begins (char *, char *);
extern int    checkrecursion (int, ENODE *);
extern void   errorexit (char *);
extern int    yyparse(void);
extern int    skipnumber (char *, int);
#else

#ifdef __STDC__
extern void   *malloc();
#else
extern char   *malloc();
#endif

extern int    yylex ();
extern void   yyerror ();
extern ENODE *node ();
extern int    math_calc_pr();
extern double eval ();
extern void   ptree ();
extern int    begins ();
extern int    checkrecursion ();
extern void   errorexit ();
extern int    yyparse();
extern int    skipnumber ();
#endif

/*
 * functuiom to be called in main program 'math', by VO
 */
extern char *get_substr(char *, char *);
int math_calc_pr(str, v)
char *str;
double *v;
{
    register char *cs;
    char *substr;
    Outfile = stdout;

    if ( str == NULL ) {
	    PR(ER,"%s: null input string...\n", myname);
	    return -1;
    }
    substr = (char *)malloc(strlen(str)+1);
    if ( substr == NULL ) {
	    PR(ER,"%s: no memory for temporal string...\n", myname);
	    return -1;
    }

    /* remove last symbols we do not need */
    cs = str + strlen(str);
    cs--;
    while (*cs == ';' || *cs == ' ' || *cs == '\t' || *cs == '\n') cs--;
    cs++; *cs = '\0';

    cs = str;
    while(get_substr(substr, cs) != NULL) {
	strcpy(math_string, substr);
	Eptr = math_string;
	while (isspace ((int)*Eptr))
		Eptr++;
	if (*Eptr == '\0' || *Eptr == '?')  {
		PR(ER,"%s: Bad input string...\n", myname);
		free((void *)substr);
		return -1;
	}
	if (iscntrl ((int)*Eptr)) {
		fprintf (stderr, "%s: control symbol.\n", myname);
		free((void *)substr);
		return -1;
	}
	if (yyparse() == PARSERROR) {
		fprintf (stderr, "%s: parse error.\n", myname);
		free((void *)substr);
		return -1;
	}
	if (Printequation)
		ptree (Outfile, Expression);
	if (fzero (Answer = eval (Expression)))
		Answer = 0.0;
	if (Printequation)
		printf (" =");
	if (Answer == UNDEFINED) {
		printf ("\tUNDEFINED\n");
		free((void *)substr);
		return -1;
	} else {
		if (Printequation) {
			putc ('\t', Outfile);
			putc ('\n', Outfile);
		}
	}
	cs += strlen(substr);
    }

    *v = Answer;

    free((void *)substr);
    return 1;
}

int yylex ()
{
        extern  YYSTYPE yylval;
        char    tmpvarname[BUFSIZ];
        int     i;
        while (isspace ((int)*Eptr))  Eptr++;
	if (begins ("cosh",  Eptr))   {Eptr += 4; return (COSH);}
	if (begins ("sinh",  Eptr))   {Eptr += 4; return (SINH);}
	if (begins ("acosh", Eptr))   {Eptr += 5; return (ACOSH);}
	if (begins ("asinh", Eptr))   {Eptr += 5; return (ASINH);}
        if (begins ("acos",  Eptr))   {Eptr += 4; return (ACOS);}
        if (begins ("asin",  Eptr))   {Eptr += 4; return (ASIN);}
        if (begins ("atan",  Eptr))   {Eptr += 4; return (ATAN);}
        if (begins ("cos",   Eptr))   {Eptr += 3; return (COS);}
        if (begins ("sin",   Eptr))   {Eptr += 3; return (SIN);}
        if (begins ("tan",   Eptr))   {Eptr += 3; return (TAN);}
        if (begins ("log",   Eptr))   {Eptr += 3; return (LOG);}
        if (begins ("ln",    Eptr))   {Eptr += 2; return (LOG);}
        if (begins ("lg",    Eptr))   {Eptr += 2; return (LOG10);}
        if (begins ("log10", Eptr))   {Eptr += 5; return (LOG10);}
        if (begins ("lg2",   Eptr))   {Eptr += 3; return (LOG2);}
        if (begins ("log2",  Eptr))   {Eptr += 4; return (LOG2);}
	if (begins ("sqrt",  Eptr))   {Eptr += 4; return (SQRT);}
        if (begins ("exp",   Eptr))   {Eptr += 3; return (EXP);}
        if (begins ("abs",   Eptr))   {Eptr += 3; return (ABS);}
        if (begins ("int",   Eptr))   {Eptr += 3; return (INT);}
        if (begins ("floor", Eptr))   {Eptr += 5; return (FLOOR);}
        if (begins ("ceil",  Eptr))   {Eptr += 4; return (CEIL);}
        if (begins ("if",    Eptr))   {Eptr += 2; return (IF);}
        if (begins ("then",  Eptr))   {Eptr += 4; return (THEN);}
        if (begins ("else",  Eptr))   {Eptr += 4; return (ELSE);}
        if (*Eptr == '$') {
                Eptr++;
                yylval.num = &Answer;
                return (NUMBER);
        }
        if (isdigit ((int)*Eptr) || *Eptr == '.') {
                Constant = (double *) malloc (sizeof (double));
                if (Constant == NULL)
                        errorexit ("Out of storage space");
                *Constant = atof (Eptr);
                yylval.num = Constant;
                Eptr += skipnumber (Eptr, 1);
                return (NUMBER);
        }
        if (isvarchar (*Eptr)) {
                for (i = 0; isvarchar (Eptr[i]); i++)
                        tmpvarname[i] = Eptr[i];
                tmpvarname[i] = (char)NULL;
                Eptr += i;
                i = 0;
                while (i < Nvar && strcmp (tmpvarname, Varname[i])) i++;
                if (i == Nvar)  {
                    Varname[i] = malloc ((unsigned) (strlen(tmpvarname)+1));
                    if (Varname[i] == NULL)
                            errorexit ("Out of storage space");
                    (void) strcpy (Varname[i], tmpvarname);
                    if (++Nvar == MAXVAR)
                            errorexit ("Too many variables");
                }
                yylval.var = i;
                return (VARIABLE);
        }
        if (begins ("!=", Eptr)) { Eptr += 2; return (NE); }
        if (begins (">=", Eptr)) { Eptr += 2; return (GE); }
        if (begins ("<=", Eptr)) { Eptr += 2; return (LE); }
        if (begins ("==", Eptr)) { Eptr += 2; return (EQ); }
        if (begins ("**", Eptr)) { Eptr += 2; return ('^'); }
        if (begins ("&&", Eptr)) { Eptr += 2; return ('&'); }
        if (begins ("||", Eptr)) { Eptr += 2; return ('|'); }

        return ((int) *Eptr++);
}

void yyerror (msg)
char    *msg;
{
        fprintf (stderr, "%s:\n", msg);
        fprintf (stderr, "Parsing error.  ");
	fprintf (stderr, "This is left in input: [%s].\n", Eptr-1);
}

ENODE *node (datum, datatype, lson, rson)
STUFF   *datum;       /* pointer to a number or an operator */
int     datatype;     /* NUMBER or VARIABLE or OPERATOR */
ENODE   *lson;        /* left part of tree */
ENODE   *rson;        /* right part of tree */
{
        ENODE *newnode;
        newnode = (ENODE *) malloc (sizeof (ENODE));
        if (newnode == ENULL)
		errorexit ("Out of storage space.");
        newnode->etype = datatype;
        if (datatype == OPERATOR)
                newnode->contents.opr = datum->opr;
        else if (datatype == VARIABLE)
                newnode->contents.var = datum->var;
        else /* (datatype == NUMBER) */
                newnode->contents.num = datum->num;
        newnode->left = lson;
        newnode->right = rson;
        return (newnode);
}


double eval (expression)
ENODE *expression;
{
        double  tmp1, tmp2;

        if (expression == ENULL)
                return (UNDEFINED);
        if (expression->etype == NUMBER)
                return (*expression->contents.num);
        if (expression->etype == VARIABLE) {
                if (Variable[expression->contents.var])
                        return (eval (Variable[expression->contents.var]));
                else
                        return (UNDEFINED);
        }

        if ((tmp2 = eval (expression->right)) == UNDEFINED)
                return (UNDEFINED);

        switch (expression->contents.opr)
        {
        case '_': return (-tmp2);
        case '!': return (fzero (tmp2) ? 1.0 : 0.0);
        case LOG: if (tmp2 <= FZERO) return (UNDEFINED);
                else return (log (tmp2));
        case LOG10: if (tmp2 <= FZERO) return (UNDEFINED);
                else return (log10 (tmp2));
        case LOG2: if (tmp2 <= FZERO)  return (UNDEFINED);
                else return (log(tmp2)/log (2.));
        case COS:   return ( cos  (tmp2));
        case SIN:   return ( sin  (tmp2));
	case COSH:  return ( cosh (tmp2));
	case SINH:  return ( sinh (tmp2));
	case ACOSH: return ( acosh(tmp2));
	case ASINH: return ( asinh(tmp2));
        case TAN:   return ( tan  (tmp2));
        case ACOS:  return ( acos (tmp2));
        case ASIN:  return ( asin (tmp2));
        case ATAN:  return ( atan (tmp2));
        case EXP:   return ( exp  (tmp2));
        case ABS:   return ( fabs (tmp2));
        case INT:   return ( (int)(tmp2));
        case FLOOR: return ( floor(tmp2));
        case CEIL:  return ( ceil (tmp2));
        case SQRT: if (tmp2 < 0.0) return (UNDEFINED);
                else return (sqrt (tmp2));
        }

        if ((tmp1 = eval (expression->left)) == UNDEFINED)
                return (UNDEFINED);
        switch (expression->contents.opr)
        {
        case '+': return (tmp1 + tmp2);
        case '-': return (tmp1 - tmp2);
        case '*': return (tmp1 * tmp2);
        case '%': if ((int) tmp2 == 0) return (tmp1);
                else return ((double) (((int) tmp1) % ((int) tmp2)));
        case '/': if (fzero (tmp2)) return (UNDEFINED);
                else return (tmp1/tmp2);
        case '^': return (pow (tmp1, tmp2));
        case '&': return ((!fzero (tmp1) && !fzero (tmp2)) ? 1.0 : 0.0);
        case '|': return ((!fzero (tmp1) || !fzero (tmp2)) ? 1.0 : 0.0);
        case '>': return (tmp1 > tmp2 ? 1.0 : 0.0);
        case '<': return (tmp1 < tmp2 ? 1.0 : 0.0);
        case EQ : return (fzero (tmp1 - tmp2) ? 1.0 : 0.0);
        case NE : return (!fzero (tmp1 - tmp2) ? 1.0 : 0.0);
        case LE : return (tmp1 <= tmp2 ? 1.0 : 0.0);
        case GE : return (tmp1 >= tmp2 ? 1.0 : 0.0);
        case ':': return (0.0); /* dummy return for ? */
        case '?':
                if (expression->right->contents.opr == ':')
                        return (!fzero (tmp1)
                                ? eval (expression->right->left)
                                : eval (expression->right->right));
		else if (!fzero (tmp1)) return (eval (expression->right));
                else return (UNDEFINED);
        default:
                fprintf (stderr, "calc: Unknown operator '%c' = %d\n",
                expression->contents.opr, expression->contents.opr);
                return (UNDEFINED);
        }
}

static char s_loc[5][5];
static char i_loc[5];
int start_calc(str)
char *str;
{
    register int i;
    register char *cs;
    char *substr;
    double Answer;

    substr = (char *)malloc(strlen(str)+1);
    if ( substr == NULL ) {
	    PR(ER,"%s: no memory for temporal string...\n", myname);
	    return -1;
    }

    /* remove last symbols we do not need */
    cs = str + strlen(str);
    cs--;
    while (*cs == ';' || *cs == ' ' || *cs == '\t' || *cs == '\n') cs--;
    cs++; *cs = '\0';

    cs = str;
    while(get_substr(substr, cs) != NULL) {
	strcpy(math_string, substr);
	Eptr = math_string;
	while (isspace ((int)*Eptr))
		Eptr++;
	if (*Eptr == '\0' || *Eptr == '?')  {
		PR(ER,"%s: Bad input string...\n", myname);
		free((void *)substr);
		return -1;
	}
	if (iscntrl ((int)*Eptr)) {
		fprintf (stderr, "%s: control symbol.\n", myname);
		free((void *)substr);
		return -1;
	}
	if (yyparse() == PARSERROR) {
		fprintf (stderr, "%s: parse error.\n", myname);
		free((void *)substr);
		return -1;
	}
	if (fzero (Answer = eval (Expression)))
		Answer = 0.0;
	cs += strlen(substr);
    }

    strcpy(s_loc[0], "x");
    strcpy(s_loc[1], "t");
    strcpy(s_loc[2], "p");
    strcpy(s_loc[3], "i");
    strcpy(s_loc[4], "l");

    i = 0; while (i < Nvar && strcmp (s_loc[0], Varname[i])) i++;
    if (i != Nvar)  i_loc[0] = i;
    i = 0; while (i < Nvar && strcmp (s_loc[1], Varname[i])) i++;
    if (i != Nvar)  i_loc[1] = i;
    i = 0; while (i < Nvar && strcmp (s_loc[2], Varname[i])) i++;
    if (i != Nvar)  i_loc[2] = i;
    i = 0; while (i < Nvar && strcmp (s_loc[3], Varname[i])) i++;
    if (i != Nvar)  i_loc[3] = i;
    i = 0; while (i < Nvar && strcmp (s_loc[4], Varname[i])) i++;
    if (i != Nvar)  i_loc[4] = i;

    free((void *)substr);
    return 1;
}

static int ind_n = -1;
extern double eval_glesp(double, double, double, ENODE *);
extern double calc_val_in(double, double, double, double, double);

double calc_val(x,t,p)
double x, t, p;
{
    double v = calc_val_in(x,t,p,0.,0.);
    return v;
}

double calc_nph(x,t,i,l)
double x, t;
int i,l;
{
    double p=0., i_f = i, l_f = l;
    double v = calc_val_in(x,t,p,i_f,l_f);
    return v;
}

double calc_val_in(x,t,p,i,l)
double x, t, p, l, i;
{
    int flag = 1;
    double  tmp1, tmp2;
    double  v[5], r = UNDEFINED;
    v[0] = x; v[1] = t; v[2] = p;  v[3] = i; v[4] = l;

    if (Expression == ENULL)
	    return (UNDEFINED);
    if (Expression->etype == NUMBER)
	    return (*Expression->contents.num);
    if (Expression->etype == VARIABLE) {
	ind_n = Expression->contents.var;
	if (Variable[Expression->contents.var])
	  return (eval_glesp(x,t,p, Variable[Expression->contents.var]));
	else
	  return (UNDEFINED);
    }

    if ((tmp2 = eval_glesp(x,t,p, Expression->right)) == UNDEFINED)
	    return (UNDEFINED);
    if (ind_n == 1 || ind_n == 2 ) {
	tmp2 = v[ind_n];
	ind_n = -1;
    }
    switch (Expression->contents.opr)
    {
    case '_': r = -tmp2;  break;
    case '!': r = (fzero (tmp2) ? 1.0 : 0.0);   break;
    case LOG: if (tmp2 <= FZERO)  r = UNDEFINED;
	      else r = log (tmp2);
	      break;
    case LOG10:
	      if (tmp2 <= FZERO) r = UNDEFINED;
	      else r = log10 (tmp2);
	      break;
    case LOG2:
	      if (tmp2 <= FZERO)  r = UNDEFINED;
	      else r = log(tmp2)/log (2.);
	      break;
    case COS:   r = cos  (tmp2);  break;
    case SIN:   r = sin  (tmp2);  break;
    case COSH:  r = cosh (tmp2);  break;
    case SINH:  r = sinh (tmp2);  break;
    case TAN:   r = tan  (tmp2);  break;
    case ACOS:  r = acos (tmp2);  break;
    case ASINH: r = asinh(tmp2);  break;
    case ACOSH: r = acosh(tmp2);  break;
    case ASIN:  r = asin (tmp2);  break;
    case ATAN:  r = atan (tmp2);  break;
    case EXP:   r = exp  (tmp2);  break;
    case ABS:   r = fabs (tmp2);  break;
    case INT:   r = (int)(tmp2);  break;
    case FLOOR: r = floor(tmp2);  break;
    case CEIL:  r = ceil (tmp2);  break;
    case SQRT:  if (tmp2 < 0.0) r = UNDEFINED;
		else r = sqrt (tmp2);
		break;
    default :
		flag = 0;
		break;
    }

    if (flag)
	return r;

    if ((tmp1 = eval_glesp(x,t,p, Expression->left)) == UNDEFINED)
	    return (UNDEFINED);
    if (ind_n == 0 ) {
	tmp1 = v[0];
	ind_n = -1;
    }
    switch (Expression->contents.opr)
    {
    case '+': r = (tmp1 + tmp2); break;
    case '-': r = (tmp1 - tmp2); break;
    case '*': r = (tmp1 * tmp2); break;
    case '%': if ((int) tmp2 == 0) r = tmp1;
	    else r = (double) (((int) tmp1) % ((int) tmp2));
	    break;
    case '/': if (fzero (tmp2)) r = UNDEFINED;
	    else r = tmp1/tmp2;
	    break;
    case '^': r = pow (tmp1, tmp2); break;
    case '&': r = ((!fzero (tmp1) && !fzero (tmp2)) ? 1.0 : 0.0); break;
    case '|': r = ((!fzero (tmp1) || !fzero (tmp2)) ? 1.0 : 0.0); break;
    case '>': r = tmp1 > tmp2 ? 1.0 : 0.0;  break;
    case '<': r = tmp1 < tmp2 ? 1.0 : 0.0;  break;
    case EQ : r = ( fzero (tmp1 - tmp2) ? 1.0 : 0.0); break;
    case NE : r = (!fzero (tmp1 - tmp2) ? 1.0 : 0.0); break;
    case LE : r = tmp1 <= tmp2 ? 1.0 : 0.0; break;
    case GE : r = tmp1 >= tmp2 ? 1.0 : 0.0; break;
    case ':': r = 0.0; /* dummy return for ? */ break;
    case '?':
	    if (Expression->right->contents.opr == ':')
		    r = (!fzero (tmp1)
			? eval_glesp(x,t,p, Expression->right->left)
			: eval_glesp(x,t,p, Expression->right->right));
	    else if (!fzero (tmp1))
			r = eval_glesp(x,t,p, Expression->right);
	    else r = UNDEFINED;
	    break;
    default:
	    fprintf (stderr, "calc: Unknown operator '%c' = %d\n",
	    Expression->contents.opr, Expression->contents.opr);
	    r = UNDEFINED;
    }

    return r;
}

double eval_glesp(x,t,p, expression)
double x, t, p;
ENODE *expression;
{
    int flag = 1;
    double  tmp1, tmp2;
    double  v[3], r = UNDEFINED;
    v[0] = x; v[1] = t; v[2] = p;

    if (expression == ENULL)
	    return (UNDEFINED);
    if (expression->etype == NUMBER)
	    return (*expression->contents.num);
    if (expression->etype == VARIABLE) {
	ind_n = expression->contents.var;
	if (Variable[expression->contents.var])
	  return (eval_glesp(x,t,p, Variable[expression->contents.var]));
	else
	  return (UNDEFINED);
    }

    if ((tmp2 = eval_glesp(x,t,p, expression->right)) == UNDEFINED)
	    return (UNDEFINED);
    if (ind_n == 1 || ind_n == 2 ) {
	tmp2 = v[ind_n];
	ind_n = -1;
    }
    switch (expression->contents.opr)
    {
    case '_': r = -tmp2;  break;
    case '!': r = (fzero (tmp2) ? 1.0 : 0.0);   break;
    case LOG: if (tmp2 <= FZERO)  r = UNDEFINED;
	      else r = log (tmp2);
	      break;
    case LOG10:
	      if (tmp2 <= FZERO) r = UNDEFINED;
	      else r = log10 (tmp2);
	      break;
    case LOG2:
	      if (tmp2 <= FZERO)  r = UNDEFINED;
	      else r = log(tmp2)/log (2.);
	      break;
    case COSH:  r = cosh (tmp2);  break;
    case SINH:  r = sinh (tmp2);  break;
    case COS:   r = cos  (tmp2);  break;
    case SIN:   r = sin  (tmp2);  break;
    case TAN:   r = tan  (tmp2);  break;
    case ACOSH: r = acosh(tmp2);  break;
    case ASINH: r = asinh(tmp2);  break;
    case ACOS:  r = acos (tmp2);  break;
    case ASIN:  r = asin (tmp2);  break;
    case ATAN:  r = atan (tmp2);  break;
    case EXP:   r = exp  (tmp2);  break;
    case ABS:   r = fabs (tmp2);  break;
    case INT:   r = (int)(tmp2);  break;
    case FLOOR: r = floor(tmp2);  break;
    case CEIL:  r = ceil (tmp2);  break;
    case SQRT:  if (tmp2 < 0.0) r = UNDEFINED;
		else r = sqrt (tmp2);
		break;
    default :
		flag = 0;
		break;
    }

    if (flag)
	return r;

    if ((tmp1 = eval_glesp(x,t,p, expression->left)) == UNDEFINED)
	    return (UNDEFINED);
    if (ind_n == 0 ) {
	tmp1 = v[0];
	ind_n = -1;
    }
    switch (expression->contents.opr)
    {
    case '+': r = (tmp1 + tmp2); break;
    case '-': r = (tmp1 - tmp2); break;
    case '*': r = (tmp1 * tmp2); break;
    case '%': if ((int) tmp2 == 0) r = tmp1;
	    else r = (double) (((int) tmp1) % ((int) tmp2));
	    break;
    case '/': if (fzero (tmp2)) r = UNDEFINED;
	    else r = tmp1/tmp2;
	    break;
    case '^': r = pow (tmp1, tmp2); break;
    case '&': r = ((!fzero (tmp1) && !fzero (tmp2)) ? 1.0 : 0.0); break;
    case '|': r = ((!fzero (tmp1) || !fzero (tmp2)) ? 1.0 : 0.0); break;
    case '>': r = tmp1 > tmp2 ? 1.0 : 0.0;  break;
    case '<': r = tmp1 < tmp2 ? 1.0 : 0.0;  break;
    case EQ : r = ( fzero (tmp1 - tmp2) ? 1.0 : 0.0); break;
    case NE : r = (!fzero (tmp1 - tmp2) ? 1.0 : 0.0); break;
    case LE : r = tmp1 <= tmp2 ? 1.0 : 0.0; break;
    case GE : r = tmp1 >= tmp2 ? 1.0 : 0.0; break;
    case ':': r = 0.0; /* dummy return for ? */ break;
    case '?':
	    if (expression->right->contents.opr == ':')
		    r = (!fzero (tmp1)
			? eval_glesp(x,t,p, expression->right->left)
			: eval_glesp(x,t,p, expression->right->right));
	    else if (!fzero (tmp1))
			r = eval_glesp(x,t,p, expression->right);
	    else r = UNDEFINED;
	    break;
    default:
	    fprintf (stderr, "calc: Unknown operator '%c' = %d\n",
	    expression->contents.opr, expression->contents.opr);
	    r = UNDEFINED;
    }

    return r;
}

void ptree (ioptr, expression)
ENODE *expression; FILE *ioptr;
{
        if (expression == ENULL)
                return;
        if (expression->etype == VARIABLE)
                {
                fprintf (ioptr, "%s", Varname[expression->contents.var]);
                return;
                }
        else if (expression->etype == NUMBER)
                {
                if (*expression->contents.num == UNDEFINED)
                        fprintf (ioptr, "UNDEFINED");
                else
                        fprintf (ioptr, Format, *expression->contents.num);
                return;
                }
        switch  (expression->contents.opr)
                {
                case FLOOR: fprintf (ioptr, "floor("); break;
                case CEIL:  fprintf (ioptr, "ceil("); break;
                case INT:   fprintf (ioptr, "(int)("); break;
                case LOG:   fprintf (ioptr, "log("); break;
                case LOG10: fprintf (ioptr, "log10("); break;
                case LOG2:  fprintf (ioptr, "log2("); break;
                case ABS:   fprintf (ioptr, "abs("); break;
                case EXP:   fprintf (ioptr, "exp("); break;
                case SQRT:  fprintf (ioptr, "sqrt("); break;
                case ATAN:  fprintf (ioptr, "atan("); break;
		case ASINH: fprintf (ioptr, "asinh("); break;
		case ACOSH: fprintf (ioptr, "acosh("); break;
                case ASIN:  fprintf (ioptr, "asin("); break;
                case ACOS:  fprintf (ioptr, "acos("); break;
                case TAN:   fprintf (ioptr, "tan("); break;
                case SIN:   fprintf (ioptr, "sin("); break;
                case COS:   fprintf (ioptr, "cos("); break;
		case SINH:  fprintf (ioptr, "sinh("); break;
		case COSH:  fprintf (ioptr, "cosh("); break;
                case '_' :  putc ('-', ioptr);
                        ptree (ioptr, expression->right); return;
                case '?':
                        fprintf (ioptr, "(if ");
                        ptree (ioptr, expression->left);
                        fprintf (ioptr, " then ");
                        if (expression->right->contents.opr == ':')
                                {
                                ptree (ioptr, expression->right->left);
                                fprintf (ioptr, " else ");
                                ptree (ioptr, expression->right->right);
                                }
                        else ptree (ioptr, expression->right);
                        putc (')', ioptr);
                        return;
                default:
                        putc ('(', ioptr);
                        ptree (ioptr, expression->left);
                        switch (expression->contents.opr)
                        {
                        case EQ: fprintf (ioptr, " == "); break;
                        case NE: fprintf (ioptr, " != "); break;
                        case GE: fprintf (ioptr, " >= "); break;
                        case LE: fprintf (ioptr, " <= "); break;
                        default:
                           fprintf (ioptr, " %c ",expression->contents.opr);
                        }
                }
        ptree (ioptr, expression->right);
        putc (')', ioptr);
}

/* Suzanne Shouman fixed a bug here. Thanks */
int  begins (s1, s2)
char *s1, *s2;
{
        int     alphlag = isvarchar (*s1);
        while (*s1)
                if (*s1++ != *s2++) return (0);
        return (alphlag ? !isvarchar(*s2) : 1);
}

int checkrecursion (varno, expr)
int     varno;      /* look for recursion involving this variable */
ENODE   *expr;      /* look for recursion of varno in this expr */
{
        if (expr == ENULL || expr->etype == NUMBER)
                return (0);

        if (expr->etype == VARIABLE)
                {
                if (expr->contents.var == varno)
                        return (1);
                if (checkrecursion (varno, Variable[expr->contents.var]))
                        return (1);
                }

        return (
			checkrecursion (varno, expr->left)
			||
			checkrecursion (varno, expr->right)
                );
}


void errorexit (string)
char *string;
{
        fprintf (stderr, "%s: %s\n", myname, string);
        exit (1);
}
#define YYABORT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab
int yyparse()
{
    register int yym, yyn, yystate;

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if ((yyn = yydefred[yystate]))
             goto yyreduce;

    if (yychar < 0) {
        if ((yychar = yylex()) < 0) yychar = 0;
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
            if (yyssp >= yyss + yystacksize - 1)
                    goto yyoverflow;

            *++yyssp = yystate = yytable[yyn];
            *++yyvsp = yylval;
            yychar = (-1);
            if (yyerrflag > 0)  --yyerrflag;
            goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;

    yyerror("syntax error.");

    ++yynerrs;

yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
                if (yyssp >= yyss + yystacksize - 1)
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
        yychar = (-1);
        goto yyloop;
    }
yyreduce:

    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)  {
    case 1:
            Expression = yyvsp[0].ex;
            break;
    case 2:
            yyval.ex = yyvsp[-1].ex;
            break;
    case 3:
            if (checkrecursion (yyvsp[-2].var, yyvsp[0].ex)) {
                fprintf (stderr, "calc: Can't have recursive definitions\n");
                Variable[yyvsp[-2].var] = NULL;
            }
            else Variable[yyvsp[-2].var] = yyvsp[0].ex;
            yyval.ex = yyvsp[0].ex;
            break;
    case 4:
            Constant = (double *) malloc (sizeof (double));
            if (Constant == NULL)
		   errorexit ("Out of storage space.");
            *Constant = eval (yyvsp[0].ex);
            Tmp1.num = Constant;
            yyval.ex = node (&Tmp1, NUMBER, ENULL, ENULL);
            break;
    case 5:
            Tmp1.opr = '+';
            yyval.ex = node (&Tmp1, OPERATOR, yyvsp[-2].ex, yyvsp[0].ex);
            break;
    case 6:
            Tmp1.opr = '-';
            yyval.ex = node (&Tmp1, OPERATOR, yyvsp[-2].ex, yyvsp[0].ex);
            break;
    case 7:
            Tmp1.opr = '*';
            yyval.ex = node (&Tmp1, OPERATOR, yyvsp[-2].ex, yyvsp[0].ex);
            break;
   case 8:
            Tmp1.opr = '%';
            yyval.ex = node (&Tmp1, OPERATOR, yyvsp[-2].ex, yyvsp[0].ex);
            break;
    case 9:
            Tmp1.opr = '/';
            yyval.ex = node (&Tmp1, OPERATOR, yyvsp[-2].ex, yyvsp[0].ex);
            break;
    case 10:
            Tmp1.opr = '^';
            yyval.ex = node (&Tmp1, OPERATOR, yyvsp[-2].ex, yyvsp[0].ex);
            break;
    case 11:
            Tmp1.opr = '_';
            yyval.ex = node (&Tmp1, OPERATOR, ENULL, yyvsp[0].ex);
            break;
    case 12:
            Tmp1.opr = EQ;
            yyval.ex = node (&Tmp1, OPERATOR, yyvsp[-2].ex, yyvsp[0].ex);
            break;
    case 13:
            Tmp1.opr = NE;
            yyval.ex = node (&Tmp1, OPERATOR, yyvsp[-2].ex, yyvsp[0].ex);
            break;
   case 14:
            Tmp1.opr = LE;
            yyval.ex = node (&Tmp1, OPERATOR, yyvsp[-2].ex, yyvsp[0].ex);
            break;
   case 15:
	    Tmp1.opr = '<';
	    yyval.ex = node (&Tmp1, OPERATOR, yyvsp[-2].ex, yyvsp[0].ex);
	    break;
   case 16:
	    Tmp1.opr = GE;
	    yyval.ex = node (&Tmp1, OPERATOR, yyvsp[-2].ex, yyvsp[0].ex);
	    break;
   case 17:
	    Tmp1.opr = '>';
	    yyval.ex = node (&Tmp1, OPERATOR, yyvsp[-2].ex, yyvsp[0].ex);
	    break;
   case 18:
	    Tmp1.opr = '&';
	    yyval.ex = node (&Tmp1, OPERATOR, yyvsp[-2].ex, yyvsp[0].ex);
	    break;
   case 19:
	    Tmp1.opr = '|';
	    yyval.ex = node (&Tmp1, OPERATOR, yyvsp[-2].ex, yyvsp[0].ex);
	    break;
   case 20:
	    Tmp1.opr = '!';
	    yyval.ex = node (&Tmp1, OPERATOR, ENULL, yyvsp[0].ex);
	    break;
    case 21:
	    Tmp1.opr = '?';
	    Tmp2.opr = ':';
	    yyval.ex = node (&Tmp1, OPERATOR, yyvsp[-4].ex,
	    node (&Tmp2, OPERATOR, yyvsp[-2].ex, yyvsp[0].ex));
	    break;
    case 22:
	    Tmp1.opr = '?';
	    yyval.ex = node (&Tmp1, OPERATOR, yyvsp[-2].ex, yyvsp[0].ex);
	    break;
     case 23:
	    Tmp1.opr = ':';
	    yyval.ex = node (&Tmp1, OPERATOR, yyvsp[-2].ex, yyvsp[0].ex);
	    break;
     case 24:
	    Tmp1.opr = ACOS;
	    yyval.ex = node (&Tmp1, OPERATOR, ENULL, yyvsp[0].ex);
	    break;
     case 25:
	    Tmp1.opr = ASIN;
	    yyval.ex = node (&Tmp1, OPERATOR, ENULL, yyvsp[0].ex);
	    break;
     case 26:
	    Tmp1.opr = ATAN;
	    yyval.ex = node (&Tmp1, OPERATOR, ENULL, yyvsp[0].ex);
	    break;
     case 27:
	    Tmp1.opr = COS;
	    yyval.ex = node (&Tmp1, OPERATOR, ENULL, yyvsp[0].ex);
	    break;
     case 28:
	    Tmp1.opr = SIN;
	    yyval.ex = node (&Tmp1, OPERATOR, ENULL, yyvsp[0].ex);
	    break;
     case 29:
	    Tmp1.opr = TAN;
	    yyval.ex = node (&Tmp1, OPERATOR, ENULL, yyvsp[0].ex);
	    break;
     case 30:
	    Tmp1.opr = LOG;
	    yyval.ex = node (&Tmp1, OPERATOR, ENULL, yyvsp[0].ex);
	    break;
     case 31:
	    Tmp1.opr = LOG10;
	    yyval.ex = node (&Tmp1, OPERATOR, ENULL, yyvsp[0].ex);
	    break;
    case 32:
	    Tmp1.opr = EXP;
	    yyval.ex = node (&Tmp1, OPERATOR, ENULL, yyvsp[0].ex);
	    break;
    case 33:
	    Tmp1.opr = ABS;
	    yyval.ex = node (&Tmp1, OPERATOR, ENULL, yyvsp[0].ex);
	    break;
    case 34:
	    Tmp1.opr = SQRT;
	    yyval.ex = node (&Tmp1, OPERATOR, ENULL, yyvsp[0].ex);
	    break;
    case 35:
	    Tmp1.opr = INT;
	    yyval.ex = node (&Tmp1, OPERATOR, ENULL, yyvsp[0].ex);
	    break;
    case 36:
	    Tmp1.opr = CEIL;
	    yyval.ex = node (&Tmp1, OPERATOR, ENULL, yyvsp[0].ex);
	    break;
    case 37:
            Tmp1.opr = FLOOR;
            yyval.ex = node (&Tmp1, OPERATOR, ENULL, yyvsp[0].ex);
            break;
    case 38:
            Tmp1.opr = LOG2;
            yyval.ex = node (&Tmp1, OPERATOR, ENULL, yyvsp[0].ex);
            break;
    case 39:
	    Tmp1.opr = SINH;
            yyval.ex = node (&Tmp1, OPERATOR, ENULL, yyvsp[0].ex);
            break;
    case 40:
	    Tmp1.opr = COSH;
            yyval.ex = node (&Tmp1, OPERATOR, ENULL, yyvsp[0].ex);
            break;
    case 41:
	    Tmp1.opr = ASINH;
            yyval.ex = node (&Tmp1, OPERATOR, ENULL, yyvsp[0].ex);
            break;
    case 42:
	    Tmp1.opr = ACOSH;
            yyval.ex = node (&Tmp1, OPERATOR, ENULL, yyvsp[0].ex);
            break;
    case 43:
            Tmp1.var = yyvsp[0].var;
            yyval.ex = node (&Tmp1, VARIABLE, ENULL, ENULL);
            break;
    case 44:
            Tmp1.num = yyvsp[0].num;
            yyval.ex = node (&Tmp1, NUMBER, ENULL, ENULL);
            break;
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];

    if (yystate == 0 && yym == 0) {
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
    if (yyssp >= yyss + yystacksize - 1)
    {
	yyerror("yacc stack overflow.");
	return (1);
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;

yyoverflow:
    yyerror("yacc stack overflow.");
yyabort:
    return (1);
yyaccept:
    return (0);
}

int
skipnumber (string, isreal)
char    *string;    /* input string, probably in number format */
int     isreal;     /* if true, then skip over real part too */
{
        register        char    *ptr;

        ptr = string;
        while (isspace (*ptr))
                ptr++;
        if (*ptr == '-' || *ptr == '+')
                ptr++;
        while (isdigit (*ptr))
                ptr++;
        if (isreal)
                {
                if (*ptr == '.')
                        ptr++;
                while (isdigit (*ptr))
                        ptr++;
                if (*ptr == 'E' || *ptr == 'e')
                        {
                        ptr++;
                        if (*ptr == '+' || *ptr == '-')
                                ptr++;
                        while (isdigit (*ptr))
                                ptr++;
                        }
                }
        return (ptr - string);
}

extern char *get_substr(substr, str)
char *substr, *str;
{
	register char *cs = str, *ps = substr;
	if (*cs != '\0') {
	    while((*ps = *cs) && *ps != ';') {ps++; cs++;}
		if (*ps == ';')
		    {*ps++ = ' '; *ps='\0'; cs++;}
		ps = substr;
	} else
		ps = NULL;
	return ps;
}
