#include <stdio.h>
#include "ff.h"

#if defined __linux__ || defined sun
int bitpix;
#else
extern int bitpix;
#endif

int sun_data_key = 0;

#ifdef __GNUC__
extern float  get_pix(FILE *);
extern double get_pix_d(FILE *);
extern void   put_pix(FILE *, float), put_pix_d(FILE *, double),
	      out_pix(FILE *, int),   cop_pix(FILE *, FILE *);
#else
extern float  get_pix();
extern double get_pix_d();
extern void   put_pix(), put_pix_d(), out_pix(), cop_pix();
#endif


#if defined sun || defined IRIX || defined _OSF_SOURCE
static int Sun_key = 1;
#else
static int Sun_key = 0;
#endif

static union _tt_ {
		char   b[8];
		short  s;
		long   l;
		float  f;
		double d;
} p;
static union _tt_ pp;

double
get_pix_d(stream)
FILE *stream;
{
	int _key_ = Sun_key ^ sun_data_key ;

	pp.b[0] = p.b[0] = getc(stream);
	switch (bitpix) {
	case SHORT:
		pp.b[1] = p.b[1] = getc(stream);
		if ( _key_ )   {
		       pp.b[0] = p.b[1];
		       pp.b[1] = p.b[0];
		}
		return (pp.s);
	case LONG:
		pp.b[1] = p.b[1] = getc(stream);
		pp.b[2] = p.b[2] = getc(stream);
		pp.b[3] = p.b[3] = getc(stream);
		if ( _key_ )   {
		       pp.b[0] = p.b[3];
		       pp.b[1] = p.b[2];
		       pp.b[2] = p.b[1];
		       pp.b[3] = p.b[0];
		}
		return ((double)pp.l);
	case FLOAT:
		pp.b[1] = p.b[1] = getc(stream);
		pp.b[2] = p.b[2] = getc(stream);
		pp.b[3] = p.b[3] = getc(stream);
		if ( _key_ )   {
		       pp.b[0] = p.b[3];
		       pp.b[1] = p.b[2];
		       pp.b[2] = p.b[1];
		       pp.b[3] = p.b[0];
		}
		return (pp.f);
	case DOUBLE:
		pp.b[1] = p.b[1] = getc(stream);
		pp.b[2] = p.b[2] = getc(stream);
		pp.b[3] = p.b[3] = getc(stream);
		pp.b[4] = p.b[4] = getc(stream);
		pp.b[5] = p.b[5] = getc(stream);
		pp.b[6] = p.b[6] = getc(stream);
		pp.b[7] = p.b[7] = getc(stream);
		if ( _key_ )   {
		       pp.b[0] = p.b[7];
		       pp.b[1] = p.b[6];
		       pp.b[2] = p.b[5];
		       pp.b[3] = p.b[4];
		       pp.b[4] = p.b[3];
		       pp.b[5] = p.b[2];
		       pp.b[6] = p.b[1];
		       pp.b[7] = p.b[0];
		}
		return (pp.d);
	case BYTE:
	default:
		return (p.b[0]);
	}
}

float
get_pix(stream)
FILE *stream;
{
	int _key_ = Sun_key ^ sun_data_key ;
	pp.b[0] = p.b[0] = getc(stream);
	switch (bitpix) {
	case SHORT:
		pp.b[1] = p.b[1] = getc(stream);
		if ( _key_ )   {
		       pp.b[0] = p.b[1];
		       pp.b[1] = p.b[0];
		}
		return (pp.s);
	case LONG:
#if (_MIPS_SZLONG == 64)
		pp.b[1] = p.b[1] = getc(stream);
		pp.b[2] = p.b[2] = getc(stream);
		pp.b[3] = p.b[3] = getc(stream);
		p.b[7] = p.b[6] = p.b[5] = p.b[4] = 0;
		if ( _key_ )   {
		       pp.b[0] = p.b[7];
		       pp.b[1] = p.b[6];
		       pp.b[2] = p.b[5];
		       pp.b[3] = p.b[4];
		       pp.b[4] = p.b[3];
		       pp.b[5] = p.b[2];
		       pp.b[6] = p.b[1];
		       pp.b[7] = p.b[0];
		}
#else
		pp.b[1] = p.b[1] = getc(stream);
		pp.b[2] = p.b[2] = getc(stream);
		pp.b[3] = p.b[3] = getc(stream);
		if ( _key_ )   {
		       pp.b[0] = p.b[3];
		       pp.b[1] = p.b[2];
		       pp.b[2] = p.b[1];
		       pp.b[3] = p.b[0];
		}
#endif
		return ((float)pp.l);
	case FLOAT:
		pp.b[1] = p.b[1] = getc(stream);
		pp.b[2] = p.b[2] = getc(stream);
		pp.b[3] = p.b[3] = getc(stream);
		if ( _key_ )   {
		       pp.b[0] = p.b[3];
		       pp.b[1] = p.b[2];
		       pp.b[2] = p.b[1];
		       pp.b[3] = p.b[0];
		}
		return (pp.f);
	case DOUBLE:
		pp.b[1] = p.b[1] = getc(stream);
		pp.b[2] = p.b[2] = getc(stream);
		pp.b[3] = p.b[3] = getc(stream);
		pp.b[4] = p.b[4] = getc(stream);
		pp.b[5] = p.b[5] = getc(stream);
		pp.b[6] = p.b[6] = getc(stream);
		pp.b[7] = p.b[7] = getc(stream);
		if ( _key_ )   {
		       pp.b[0] = p.b[7];
		       pp.b[1] = p.b[6];
		       pp.b[2] = p.b[5];
		       pp.b[3] = p.b[4];
		       pp.b[4] = p.b[3];
		       pp.b[5] = p.b[2];
		       pp.b[6] = p.b[1];
		       pp.b[7] = p.b[0];
		}
		return ((float)pp.d);
	case BYTE:
	default:
		return ((float)p.b[0]);
	}
}

#ifdef __GNUC__
void put_pix_d(FILE *stream, double val)
#else
void put_pix_d(stream, val)
FILE *stream;
double val;
#endif
{
	int _key_ = Sun_key ^ sun_data_key ;

	switch (bitpix) {
	case SHORT:
		pp.s = p.s = (int)val;
		if ( _key_ )   {
		       p.b[0] = pp.b[1];
		       p.b[1] = pp.b[0];
		}
		putc(p.b[0], stream); putc(p.b[1], stream);
		break;
	case LONG:
		pp.l = p.l = (long)val;
		if ( _key_ )   {
		       p.b[0] = pp.b[3];
		       p.b[1] = pp.b[2];
		       p.b[2] = pp.b[1];
		       p.b[3] = pp.b[0];
		}
		putc(p.b[0], stream); putc(p.b[1], stream);
		putc(p.b[2], stream); putc(p.b[3], stream);
		break;
	case FLOAT:
		pp.f = p.f = (float)val;
		if ( _key_ )   {
		       p.b[0] = pp.b[3];
		       p.b[1] = pp.b[2];
		       p.b[2] = pp.b[1];
		       p.b[3] = pp.b[0];
		}
		putc(p.b[0], stream); putc(p.b[1], stream);
		putc(p.b[2], stream); putc(p.b[3], stream);
		break;
	case DOUBLE:
		pp.d = p.d = val;
		if ( _key_ )   {
		       p.b[0] = pp.b[7];
		       p.b[1] = pp.b[6];
		       p.b[2] = pp.b[5];
		       p.b[3] = pp.b[4];
		       p.b[4] = pp.b[3];
		       p.b[5] = pp.b[2];
		       p.b[6] = pp.b[1];
		       p.b[7] = pp.b[0];
		}
		putc(p.b[0], stream); putc(p.b[1], stream);
		putc(p.b[2], stream); putc(p.b[3], stream);
		putc(p.b[4], stream); putc(p.b[5], stream);
		putc(p.b[6], stream); putc(p.b[7], stream);
		break;
	case BYTE:
	default:
		p.s = (int)val;
		putc(p.b[0], stream);
		break;
	}
}

#ifdef __GNUC__
void put_pix(FILE *stream, float val)
#else
void put_pix(stream, val)
FILE *stream;
float val;
#endif
{
	int _key_ = Sun_key ^ sun_data_key ;

	switch (bitpix) {
	case SHORT:
		pp.s = p.s = (int)val;
		if ( _key_ )   {
		       p.b[0] = pp.b[1];
		       p.b[1] = pp.b[0];
		}
		putc(p.b[0], stream); putc(p.b[1], stream);
		break;
	case LONG:
		pp.l = p.l = (long)val;
		if ( _key_ )   {
		       p.b[0] = pp.b[3];
		       p.b[1] = pp.b[2];
		       p.b[2] = pp.b[1];
		       p.b[3] = pp.b[0];
		}
		putc(p.b[0], stream); putc(p.b[1], stream);
		putc(p.b[2], stream); putc(p.b[3], stream);
		break;
	case FLOAT:
		pp.f = p.f = (float)val;
		if ( _key_ )   {
		       p.b[0] = pp.b[3];
		       p.b[1] = pp.b[2];
		       p.b[2] = pp.b[1];
		       p.b[3] = pp.b[0];
		}
		putc(p.b[0], stream); putc(p.b[1], stream);
		putc(p.b[2], stream); putc(p.b[3], stream);
		break;
	case DOUBLE:
		pp.d = p.d = val;
		if ( _key_ )   {
		       p.b[0] = pp.b[7];
		       p.b[1] = pp.b[6];
		       p.b[2] = pp.b[5];
		       p.b[3] = pp.b[4];
		       p.b[4] = pp.b[3];
		       p.b[5] = pp.b[2];
		       p.b[6] = pp.b[1];
		       p.b[7] = pp.b[0];
		}
		putc(p.b[0], stream); putc(p.b[1], stream);
		putc(p.b[2], stream); putc(p.b[3], stream);
		putc(p.b[4], stream); putc(p.b[5], stream);
		putc(p.b[6], stream); putc(p.b[7], stream);
		break;
	case BYTE:
	default:
		p.s = (int)val;
		putc(p.b[0], stream);
		break;
	}
}

void out_pix(stream,val)
FILE *stream;
int val;
{
	int _key_ = Sun_key ^ sun_data_key ;

	register short *sprt;
	register long *lprt;
	register float *fprt;

	switch (bitpix) {
	case SHORT:
		sprt = (short *)(&val);
		pp.s = p.s = *sprt;
		if ( _key_ )   {
		       p.b[0] = pp.b[1];
		       p.b[1] = pp.b[0];
		}
		putc(p.b[0], stream); putc(p.b[1], stream);
		break;
	case LONG:
		lprt = (long *)(&val);
		pp.l = p.l = *lprt;
		if ( _key_ )   {
		       p.b[0] = pp.b[3];
		       p.b[1] = pp.b[2];
		       p.b[2] = pp.b[1];
		       p.b[3] = pp.b[0];
		}
		putc(p.b[0], stream); putc(p.b[1], stream);
		putc(p.b[2], stream); putc(p.b[3], stream);
		break;
	case FLOAT:
		fprt = (float *)(&val);
		pp.f = p.f = *fprt;
		if ( _key_ )   {
		       p.b[0] = pp.b[3];
		       p.b[1] = pp.b[2];
		       p.b[2] = pp.b[1];
		       p.b[3] = pp.b[0];
		}
		putc(p.b[0], stream); putc(p.b[1], stream);
		putc(p.b[2], stream); putc(p.b[3], stream);
		break;
	case BYTE:
	default:
		putc(val, stream);
		break;
	}
}

void cop_pix(i_stream, o_stream)
FILE *i_stream, *o_stream;
{
	putc( getc(i_stream), o_stream);
	switch (bitpix) {
	case SHORT:
		putc( getc(i_stream), o_stream);
		break;
	case LONG:
	case FLOAT:
		putc( getc(i_stream), o_stream);
		putc( getc(i_stream), o_stream);
		putc( getc(i_stream), o_stream);
		break;
	case DOUBLE:
		putc( getc(i_stream), o_stream);
		putc( getc(i_stream), o_stream);
		putc( getc(i_stream), o_stream);
		putc( getc(i_stream), o_stream);
		putc( getc(i_stream), o_stream);
		putc( getc(i_stream), o_stream);
		putc( getc(i_stream), o_stream);
		break;
	case BYTE:
	default:
		break;
	}
}

/* for FORTRAN use */
extern FILE *_fp_FORTRAN_;

void set_bit__(bitp)
int *bitp;
{
     bitpix = *bitp;
}

float get_pix__()
{
	return  get_pix (_fp_FORTRAN_);
}

void put_pix__(val)
float *val;
{
	put_pix (_fp_FORTRAN_, *val);
}

