#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <unistd.h>
#include <string.h>

#include "glesp.h"
#include "glespol.h"
#define PR      fprintf
#define ER      stderr

#define MOD(a,p)   ((a) - (p) * (int)((a)/(p)))
#define ABS(x)     ((x) < 0   ? -(x) : (x))
#define MAX(x,y)   ((x) > (y) ?  (x) : (y))
#define MIN(x,y)   ((x) < (y) ?  (x) : (y))


extern void signal_Pol(int *, int *, int *, int *, int *,
	int *, int *, int *, int *,
	int *, double *, double *, double *, double *, int *,
	double *, int *,
	double *,double *,double *,double *,double *,double *,
	double *,double *,
	int *, int *, double *,double *,double *,double *,
	double *,double *,double *,double *,double *,double *,double *);



extern void start_clm(int *, int *, double *, double *);
extern void lgndr_Mn(int *, double *, int *, int *, double *,
		     double *, double *, double *, int *);
extern void map_TM(int, int, int, int, int,
		int *, double, int, int, int, int,
		double *, double *, double *, double *);
extern void PM_map(int *,int *,int *,int,int *,int,int,int,int,int *,
		double *, int *, double *, double *, double *, double *,
		double *, double *, double *);
extern void start_L0(int, int, int, double *);
extern void start_ll(int, int, int, double *, double *, double *, double *);
extern void lgndr_0(int, int, double, double *);
extern void lgndr_Ln(int,int,int,double,double,double *,double *,double *,
		double *, int *);
extern void Pll_n(int, int, int, double *,int,double,double,
		double *,int,double *,int *);
extern void map_TL(int *, int *, int *, int, int,
		double *,int,int,int,double *,double *,double *,double *,
		int *);
extern void PL_map(int *,int *,int *,int *,int *,int,int,int,int *,
		double *,int *,double *,int,double *,double *,double *,
		double *,double *,double *);



extern int lmin_ylm_hpix(int, double);
extern void start_time(void), print_time(void);
extern double return_time(void);
int _lmin_;
double _enorm_;
extern int max_double_(void);

/*
   input parameters: x(Nx) - coordinates on
   the sphere, f(Nx,Nph(ix)) - signal.
   Q(Nx,Nph(ix)) & U(Nx,Nph(ix)) - plarizations,
   Nph - number of cells vs. phi for a given x
   output: - f(l,m+1) - a_lm_c, f(l,Lmx+m+2) - a_lm_s,
   output: - Q&U(l,m+1) - real a_lm, Q&U(l,Lmx+m+2) - imag a_lm,
   a((l,-m)=(-1)^m a(l,m)*
 ------------------------------------------------------------ *
 totaly zero, because of memory allocation with 'calloc' in C
 */



extern void fftw_b(int, double *, double *);
extern void fftw_f(int, double *, double *);
/*
C   fast loop over m - SUM_m[a_{lm}e^{i m phi}]
*/
extern int sym_grid;
void sig_fast3_pol(Nmx,Nmp,Jmx,Lmx,Nx,Nph,K_temp,
	    apm,bpm,c,f,wsave,K_pol,Q,qc,qs,U,uc,us)
int *Nmx, *Nmp, *Jmx, *Lmx, *Nx, *Nph;
int *K_temp;
double *apm, *bpm, *c, *f, *wsave;
int *K_pol;
register double *Q, *qc, *qs, *U, *uc, *us;
{
    register int ix, ic, ip,  ii, ix_s, iis;
    register int nx = *Nmx, nb = *Nmp, lmx = *Lmx;
    register double sq2 = M_SQRT2, hs = 0.5;
    int Kx = sym_grid > 0 ? (*Nx + 1)/2 :  *Nx;

    /*  loop over x  */
    ix_s = *Nx - 1;
    iis = ix_s * nb;
    for(ix=ii=0;    ix< Kx;   ix++,ii+=nb,ix_s--,iis-=nb) {
	register int mi, mj, Mx;
	int nphi_work = Nph[ix];

	Mx = nphi_work;
//      if(2*Mx+1 > nphi_work)  Mx = (nphi_work-1)/2;
	if(Mx > lmx)  Mx = lmx;

//      RFFTI(Nph[ix], wsave);
	if ( *K_temp > 0 && f != (double *)0) {
	    register double *fi = f + ii;
	    c[0] = sq2 * apm[ix];
	    ic=0;
	    for (ip=1,mi=nx+ix; ip <= Mx; ip++,mi+=nx) {
		  c[++ic]=apm[mi];
		  c[++ic]=bpm[mi];
	    }
	    ic++;
	    if(ic < nphi_work)
		for(ip=ic; ip<nphi_work; ip++)   c[ip]=0.0;

	    /* RFFTB(Nph[ix],c,wsave);  */
	    fftw_f(nphi_work, c, wsave);
	    for(ip=0; ip<nphi_work; ip++)   *(fi+ip) = hs * c[ip];

	    if (sym_grid > 0) {  /* then calculation for south pole */
		if (ix_s != ix)  {
		    c[0] = sq2 * apm[ix_s];
		    ic = 0;
		    for(ip=1,mj=nx+ix_s; ip<= lmx; ip++,mj+=nx) {
			  c[++ic] = apm[mj];
			  c[++ic] = bpm[mj];
		    }
		    ++ic;
		    if (ic < nphi_work)
			  for (ip=ic; ip<nphi_work; ip++)   c[ip] = 0.0;

		    fftw_f(nphi_work, c, wsave);

		    fi = f + iis;
		    for(ip=0; ip<nphi_work; ip++)  *(fi+ip) = hs * c[ip];
		}
	    }
	}            /* K_temp  */
	if(*K_pol > 0) {
	    register double *qi = Q + ii;
	    if (Q != (double *)0) {
		c[0] = sq2 * qc[ix];
		ic=0;
		for (ip=1,mi=nx+ix; ip <= lmx; ip++,mi+=nx) {
		    c[++ic] = qc[mi];
		    c[++ic] = qs[mi];
		}
		ic++;
		if(ic < nphi_work)  {
		    for(ip=ic; ip<nphi_work; ip++)   c[ip]=0;
		}
		/* RFFTB(Nph[ix],c,wsave);  */
		fftw_f(nphi_work, c, wsave);
		for(ip=0; ip<nphi_work; ip++)   *(qi+ip) = hs * c[ip];

		if (sym_grid > 0) {  /* then calculation for south pole */
		    if (ix_s != ix) {
			c[0] = sq2 * qc[ix_s];
			ic = 0;
			for(ip=1,mj=nx+ix_s; ip<= lmx; ip++,mj+=nx) {
			      c[++ic] = qc[mj];
			      c[++ic] = qs[mj];
			}
			++ic;
			if (ic < nphi_work)
			      for (ip=ic; ip<nphi_work; ip++)   c[ip] = 0.0;

			fftw_f(nphi_work, c, wsave);

			qi = Q + iis;
			for(ip=0; ip<nphi_work; ip++)  *(qi+ip) = hs*c[ip];
		    }
		}
	    }
	    if (U != (double *)0) {
		register double *ui = U + ii;
		c[0] = sq2 * uc[ix];
		ic=0;
		for (ip=1,mi=nx+ix; ip <= lmx; ip++,mi+=nx) {
		    c[++ic]=uc[mi];
		    c[++ic]=us[mi];
		}
		ic++;
		if(ic < nphi_work) {
		  for(ip=ic; ip<nphi_work; ip++)
			  c[ip]=0 ;
		}
		/* RFFTB(Nph[ix],c,wsave);  */
		fftw_f(nphi_work, c, wsave);
		for(ip=0; ip<nphi_work; ip++)    *(ui+ip) = hs * c[ip];

		if (sym_grid > 0) {  /* then calculation for south pole */
		    if (ix_s != ix)  {
			c[0] = sq2 * uc[ix_s];
			ic = 0;
			for(ip=1,mj=nx+ix_s; ip<= lmx; ip++,mj+=nx) {
			      c[++ic] = uc[mj];
			      c[++ic] = us[mj];
			}
			++ic;
			if (ic < nphi_work)
			      for (ip=ic; ip<nphi_work; ip++)   c[ip] = 0.0;

			fftw_f(nphi_work, c, wsave);

			ui = U + iis;
			for(ip=0; ip<nphi_work; ip++)  *(ui+ip) = hs*c[ip];
		    }
		}
	    }
	}   /* K_pol */
    }      /*  ix   */
    return;
}

void signal_Pol(Nmx,Nmp,Jmx,Lmn,Lmx,Nx,Ksym,Ksml,Ktst,
		 K_temp,eps1,eps2,x,sqx,Mmax,f,Nph,
		 glm, wsave,c, abc, cc, cf,apm,bpm,
		 Mlim, K_pol, cpL, cpM, acL, pqu, Q,U,qc,uc,qs,us, xlbd)
int *Nmx, *Nmp, *Nx, *Jmx;
int *Nph;
int *Lmn, *Lmx;
int *Ksym, *Ksml, *Ktst, *K_temp, *Mmax, *Mlim;
double *eps1, *eps2;
register double *x, *sqx, *f;
double *wsave, *cf, *glm, *c, *abc, *cc;
double *apm, *bpm;
int *K_pol;
double *cpL, *cpM, *acL;
double *xlbd, *pqu;
register double *Q, *U, *qc, *uc, *qs, *us;
{
    register int i, j, l, ii, nx=*Nmx, nb=*Nmp, lmx = *Lmx;
    double ds2 = M_SQRT2, pi = M_PI;
    register double tnorm=2./sqrt(2.*pi),  /* factor 2 due to m & -m */
		    nul = 0.0;
    int lmin = *Lmn == 1 ? 2 : *Lmn;
    _lmin_ = max_double_();
    _enorm_ = pow(10., (double)_lmin_);   /* 10^Lmin */

    int NTml=0, NTeps=0, NPml=0, NPeps=0;

    /* ---correction for a_lm with m=0 */
    for(l=1; l<= lmx; l++) {
	if (f != (double *)0)
	    f[l] /= ds2;          /*  for m=0 */
	if (*K_pol > 0) {
	    Q[l] /= ds2;          /*  for m=0 */
	    U[l] /= ds2;          /*  for m=0 */
	}
    }

    if (glesp_comments) {
	start_time();
	PR(ER, "Legendre polynomials: ");
    }
    if(*Ksml < 0) {
	extern void sig_lgndr_M(), sig_lgndr_Mu();
//        PR(ER, "sig-lgndr_M, Ksml=%d, Ksym=%d\n", *Ksml, *Ksym);
	sig_lgndr_M(Nmx,Nmp,Jmx,&lmin,Lmx,Ksym,eps1,eps2,
	      K_temp,Nx,x,sqx,Mmax,f,glm,xlbd,c,apm,bpm,
	      &NTml, &NTeps, &NPml, &NPeps,cpM,
	      Mlim,K_pol,Q,qc,qs,U,uc,us);
    }
    if(*Ksml > 0) {
	extern void sig_lgndr_LL();
	PR(ER, "sig-lgndr_L, Ksml=%d, Ksym=%d\n", *Ksml, *Ksym);
	sig_lgndr_LL(Nmx,Nmp,Jmx,&lmin,Lmx,Ksym,eps1,eps2,
		K_temp,Nx,x,sqx,f,cc,abc,Mmax,glm,apm,bpm,
		&NTml, &NTeps, &NPml, &NPeps,cpL,acL,
		K_pol,Q,qc,qs,U,uc,us,xlbd);
    }
// PR(ER, "NTml=%d, NTeps=%d, NPml=%d, NPeps=%d\n", NTml, NTeps, NPml, NPeps);

    /* add dipole for anisotropy map */
    if (f != (double *)0 && *Lmn == 1) {
	extern void sig_dipole_T(int, int, int, int, int,
	    double *, double *, double *, double *);
	int nbuf = (*Lmx+1)*2;
	sig_dipole_T(*Nmx, nbuf, *Lmx, *Ksym, *Nx, x,f,apm,bpm);
	if (glesp_comments)
	    PR(ER, "Time for polynomials: ");
    }

    if (glesp_comments)
	PR(ER, "%gs\n", return_time());
//  print_time();

    for(ii=i=0; i< nx;  i++,ii+=nb) {
	for(j=0; j< nb; j++) {
	    register int jj = ii + j;
	    if (f != (double *)0) f[jj] = nul;
	    if (Q != (double *)0)
		 Q[jj] = U[jj] = nul;
	}
    }

//  PR(ER, "sig-fast\n");
    if (glesp_comments)
	PR(ER, "Fourier transform:    ");

    sig_fast3_pol(Nmx,Nmp,Jmx,Lmx,Nx,Nph,K_temp,
	   apm,bpm,cf,f,wsave,K_pol,Q,qc,qs,U,uc,us);

    if (glesp_comments)
	PR(ER, "%gs\n", return_time());
//  print_time();
//{
//int ntot=0;
//for(i=0; i<nx; i++) {
//register int n = Nph[i];
//ntot += n;
//}
//PR(ER, "ntot=%d, nx=%d, np=%d, n0=%d\n", ntot, *Nx, Nph[(nx+1)/2], Nph[0]);
//}
    /* renormalization and test of integral */
    for(ii=i=0; i<nx; i++,ii+=nb) {
	register int n = Nph[i];
	for(j=0; j<n; j++) {
	    register int jj = ii + j;
	    if (f != (double *)0)
		f[jj] *= tnorm;
	    if(*K_pol > 0.) {
		    Q[jj] *= 2*tnorm;
		    U[jj] *= 2*tnorm;
	    }
	}
    }
    return;
}


/*
C   loop over l - SUM_l[a_{lm}P_l^m(x_p)]
C    input: f(i,j)=alm, x(ix)
C   output: apm,bpm (m,ix)
      IMPLICIT REAL*8(a-h,o-y)
      DIMENSION x(Nx),f(Nmx,Nmp),sqx(Nmx)
      DIMENSION Mmax(Nx)
      DIMENSION apm(0:Jmx,Nmx),bpm(0:Jmx,Nmx)
      DIMENSION Q(Nmx,Nmp),U(Nmx,Nmp)
      DIMENSION qc(0:Jmx,Nmx),qs(0:Jmx,Nmx)
      DIMENSION uc(0:Jmx,Nmx),us(0:Jmx,Nmx)
      DIMENSION glm(Jmx+1),xlbd(2*Jmx+3),c(2*Jmx+1)
C      EQUIVALENCE (c,cf(Nmp))
      DIMENSION cpM(4*Jmx,Jmx+2)

*    generate maps by coefficients
*/
void sig_lgndr_M(Nmx,Nmp,Jmx,Lmn,Lmx,Ksym,eps1,eps2,
		      K_temp,Nx,x,sqx,Mmax,f,glm,xlbd,c,apm,bpm,
		      NTml,NTeps,NPml,NPeps,cpM,
		      Mlim,K_pol,Q,qc,qs,U,uc,us)
int *Nmx, *Nmp, *Jmx, *Lmn, *Lmx, *Ksym;
double *eps1, *eps2;
int *K_temp, *Nx, *Mmax;
double *x, *sqx, *f, *glm, *xlbd, *c, *apm, *bpm;
int *NTml, *NTeps, *NPml, *NPeps;
double *cpM;
int *Mlim, *K_pol;
double *Q, *qc, *qs, *U, *uc, *us;

{
    register int m, ix, jx;
    register int Kx = *Nx, nx1 = *Nx - 1;
//    int Kxf = -1;
    int mb = *Lmx+1;
    int Lb;
    double Enrm = pow(10., (double)*Mlim);
    int nbuf = 2 * (*Lmx + 1);

    jx = -1;

    if(*Ksym > 0) Kx=(*Nx+1)/2;

    for(m=0; m<= *Lmx; m++) {       /* for all m */
       double eps = *eps2;
       double xc, cmm;
       int L0, sign, mv = m;

       if(m < 100) eps = *eps1;

       L0=m;
       if(L0 < *Lmn)  L0 = *Lmn;
       sign=1-2*MOD((L0+m),2);
       Lb = mb+m;
       start_clm(Lmx, &mv, &cmm,c);

       for(ix=0; ix<Kx; ix++) {         /* loop over x(ix) */
	    if (m <= Mmax[ix]) {
		if(*Ksym > 0) {
		   jx = nx1-ix;
		   if(jx <= ix) jx = -100;
		}
		xc = x[ix];
		lgndr_Mn(Mlim, &Enrm,Lmx,&mv,&cmm,c, &xc,glm,NTml);

		if(*K_temp > 0)
		    map_TM(*Nmx, nbuf, *Jmx, *Lmx,L0,
			     NTeps, eps,m,ix,jx,Lb,f,glm,apm,bpm);
		if(*K_pol > 0) {
		    int ax = sign;
		    extern void Plm_n2(), PM_map0();
//                  Plm_n(*Jmx,*Lmx,L0,m,cpM, &ax,xc,glm,Kxf,xlbd,NPml);
		    ax = sign;
		    Plm_n2(*Jmx,*Lmx,L0,m,cpM, xc,glm, xlbd, NPml);
//                  PM_map(Nmx,Nmp,Jmx,L0,Lmx,m,Lb,ix,jx, &ax,xlbd,
//                         NPeps, &eps,Q,U,qc,qs,uc,us);
		    PM_map0(*Nmx,nbuf,*Jmx,L0,*Lmx,m,Lb,ix,jx, ax,xlbd,
			   NPeps, eps,Q,U,qc,qs,uc,us);
		}       /* for K_pol>0    */
	    }         /* for M<Mmax(ix) */
       }            /* loop over x    */
    }             /* loop over m    */

    return;
}

void map_TM(Nmx,nbuf,Jmx,Lmx,L0,Nt,eps,m,ix,jx,Lb, f,glm,apm,bpm)
int Nmx, nbuf, Jmx, Lmx;
int L0, ix, jx, m, Lb;
double eps;
double *f, *glm, *apm, *bpm;
int *Nt;
{
    register int l; // , llp = Nmp * L0;
    int l0m = L0 + m;
    int ax=1-2*MOD(l0m,2);
    register double a_n = 0.0, a_s = 0.0,
		    b_n = 0.0, b_s = 0.0;
    int mm = m * Nmx, mi=mm+ix, mj=mm+jx;
//  double *f_r = f + m, *f_i = f + Lb;
    double *f_r = f + m  * nbuf,
	   *f_i = f + Lb * nbuf;

//  for(l=L0; l <= Lmx; l++, llp += Nmp) {    /* loop over L */
    for(l=L0; l <= Lmx; l++) {    /* loop over L */
	double gl1 = glm[l+1], agl, bgl;

	if(ABS(gl1) > eps) {
//             agl = gl1 * f_r[llp];
//             bgl = gl1 * f_i[llp];
	       agl = gl1 * f_r[l];
	       bgl = gl1 * f_i[l];
	      (*Nt)++;

	       a_n += agl;
	       b_n += bgl;
	       if(jx > 0) {           /* for symmetric x */
		   if (ax < 0) {
		       a_s -= agl;
		       b_s -= bgl;
		   } else {
		       a_s += agl;
		       b_s += bgl;
		   }
	       }             /* for symmetric x */
	  }             /* for glm< eps */
	  ax = -ax;
    }          /* end of loop over L */

    apm[mi] += a_n;
    bpm[mi] += b_n;
    if(jx > 0) {
	apm[mj] += a_s;
	bpm[mj] += b_s;
    }
    return;
}

void PM_map0(Nmx, nbuf,Jmx,L1, Lmx, m,Lb, ix,jx, ax, xlbd,
		       Np, eps, Q,U,qc,qs,uc,us)
int Nmx, nbuf, Jmx, Lmx;
int L1, Lb;
int m, ix, jx;
int *Np;
int ax;
double eps;
double *Q,*U,*qc,*qs,*uc,*us,*xlbd;
{
    register int l, llr, lli;
    int mm = m * Nmx;
    int mi = mm + ix, mj = mm + jx;
    double *xr = xlbd,
	   *xi = xlbd + Jmx+1;
    double  qc_mi=0.0, qs_mi = 0.0, uc_mi = 0.0, us_mi = 0.0,
	    qc_mj=0.0, qs_mj = 0.0, uc_mj = 0.0, us_mj = 0.0;
    double fx, px, qr, qi, ur, ui;
    double fx_qr,  px_ui, fx_qi,  px_ur, px_qi, fx_ur, px_qr, fx_ui;
    double *Qr, *Qi, *Ur, *Ui;

    /* loop over L     */
//  llr = Nmp * L1 + m;
//  lli = Nmp * L1 + Lb;

    llr = nbuf * m ;
    lli = nbuf * Lb;
    Qr = Q + llr;
    Qi = Q + lli;
    Ur = U + llr;
    Ui = U + lli;

//  for (l=L1; l<= Lmx; l++,llr+=Nmp,lli+=Nmp) { /* loop over L  */
    for (l=L1; l<= Lmx; l++) { /* loop over L  */
	fx =  xr[l]; px =  xi[l];

	if( ABS(fx) > eps || ABS(px) > eps ) {
//          qr = Q[llr]; qi=Q[lli]; ur=U[llr]; ui=U[lli];
	    qr = Qr[l]; qi=Qi[l]; ur=Ur[l]; ui=Ui[l];
	    fx_qr=fx*qr; px_ui=px*ui; fx_qi=fx*qi; px_ur=px*ur;
	    px_qi=px*qi; fx_ur=fx*ur; px_qr=px*qr; fx_ui=fx*ui;

	    (*Np)++;

	    qc_mi +=  fx_qr - px_ui;
	    qs_mi +=  fx_qi + px_ur;
	    uc_mi +=  px_qi + fx_ur;
	    us_mi += -px_qr + fx_ui;

	    if(jx > 0) {
		if ( ax > 0 ) {
		      qc_mj +=  fx_qr + px_ui;
		      qs_mj +=  fx_qi - px_ur;
		      uc_mj += -px_qi + fx_ur;
		      us_mj +=  px_qr + fx_ui;
		} else {
		      qc_mj += -fx_qr - px_ui;
		      qs_mj += -fx_qi + px_ur;
		      uc_mj +=  px_qi - fx_ur;
		      us_mj += -px_qr - fx_ui;
		}
	    }
	}
	ax = -ax;
    }     /* loop over L */

    qc[mi] += qc_mi;
    qs[mi] += qs_mi;
    uc[mi] += uc_mi;
    us[mi] += us_mi;
    if(jx > 0) {
	qc[mj] += qc_mj;
	qs[mj] += qs_mj;
	uc[mj] += uc_mj;
	us[mj] += us_mj;
    }
    return;
}

void PM_map(Nmx,Nmp,Jmx,L1, Lmx, m,Lb, ix,jx, ax, xlbd,
		       Np, eps, Q,U,qc,qs,uc,us)
int *Nmx, *Nmp, *Jmx, *Lmx;
int L1, Lb;
register int m, ix, jx;
int *Np;
int *ax;
double *eps;
register double *Q,*U,*qc,*qs,*uc,*us,*xlbd;
{
    register int l, llp;
    int mm = m * *Nmx;
    register int mi = mm + ix, mj = mm + jx;
    register double *xr = xlbd + L1,
		    *xi = xlbd + L1 + *Jmx+1;
    double  *qc_mi = qc+mi, *qs_mi = qs+mi, *uc_mi = uc+mi, *us_mi = us+mi;
    double  *qc_mj = qc+mj, *qs_mj = qs+mj, *uc_mj = uc+mj, *us_mj = us+mj;


    /* loop over L     */
    llp= *Nmp * L1;
    for (l=L1; l<= *Lmx; l++) { /* loop over L  */
	register double fx =  *xr;
	register double px =  *xi;

	if( ABS(fx) > *eps || ABS(px) > *eps) {
	    register int lr =llp+m, li=llp+Lb;
	    register double qr = Q[lr], qi=Q[li], ur=U[lr], ui=U[li];
	    double c1 = fx * qr, c2 = px * ui, c3 = fx * qi, c4 = px * ur,
		   c5 = px * qi, c6 = fx * ur, c7 = px * qr, c8 = fx * ui;
	    (*Np)++;

//          qc[mi] +=  fx * qr - px * ui,
//          qs[mi] +=  fx * qi + px * ur,
//          uc[mi] +=  px * qi + fx * ur,
//          us[mi] += -px * qr + fx * ui;

	    *qc_mi +=  c1 - c2;
	    *qs_mi +=  c3 + c4;
	    *uc_mi +=  c5 + c6;
	    *us_mi += -c7 + c8;

	    if(jx > 0) {
//              if ( *ax > 0 )
//                    px = -px;
//              else
//                    fx = -fx;
		if ( *ax > 0 )
		      {c2 = -c2; c4 = -c4; c5 = -c5; c7 = -c7;}
		else
		      {c1 = -c1; c3 = -c3; c6 = -c6; c8 = -c8;}
//              qc[mj] +=  fx * qr - px * ui,
//              qs[mj] +=  fx * qi + px * ur,
//              uc[mj] +=  px * qi + fx * ur,
//              us[mj] += -px * qr + fx * ui;
		*qc_mj +=  c1 - c2;
		*qs_mj +=  c3 + c4;
		*uc_mj +=  c5 + c6;
		*us_mj += -c7 + c8;
	    }
	}
	*ax = -(*ax);
	xr++, xi++;
	llp += *Nmp;
    }     /* loop over L */

    return;
}


/*
C   loop over l - SUM_l[a_{lm}P_l^m(x_p)]
C    input: f(i,j)=alm, x(ix)
C   output: apm,bpm (m,ix)
       IMPLICIT REAL*8(a-h,o-z)
       DIMENSION x(Nx),f(Nmx,Nmp),sqx(Nmx)
       DIMENSION Mmax(Nmx)
       DIMENSION apm(0:Jmx,Nmx),bpm(0:Jmx,Nmx)
       DIMENSION Q(Nmx,Nmp),U(Nmx,Nmp)
       DIMENSION qc(0:Jmx,Nmx),qs(0:Jmx,Nmx)
       DIMENSION uc(0:Jmx,Nmx),us(0:Jmx,Nmx)
       DIMENSION xlbd(2*Jmx+3),glm(Jmx+1)
       DIMENSION cpL(3*Jmx*(Jmx+1)),acL(2*Jmx*(Jmx+1))
       DIMENSION cc(4*Jmx+4),abc(4*Jmx)
*/

void  sig_lgndr_LL(Nmx,Nmp,Jmx,Lmn,Lmx,Ksym,eps1,eps2,
      K_temp,Nx,x,sqx,f,cc,abc,Mmax,glm,apm,bpm,
      NTml,NTeps,NPml,NPeps,cpL,acL,
      K_pol,Q,qc,qs,U,uc,us,xlbd)
int *Nmx, *Nmp, *Jmx, *Lmn, *Lmx, *Ksym;
double *eps1, *eps2;
int *K_temp, *Nx, *Mmax;
double *x, *sqx, *f, *cc, *abc, *glm, *apm, *bpm;
int *NTml, *NTeps, *NPml, *NPeps;
double *cpL, *acL;
int *K_pol;
double *Q, *qc, *qs, *U, *uc, *us, *xlbd;
{
    register int l, ix;
    int mb= *Lmx+1,
	 jx = -1,
	 Kxf= -1,
	 L1 =  1,
	 Kx = *Nx;
    int ax, nx1= *Nx -1;
    double cll;

    if(*Ksym > 0) Kx=(*Nx+1)/2;          /* for symmetric x */

    start_L0(*Jmx, *Lmn, *Lmx,cc);

    for (l= *Lmn; l<= *Lmx; l++)  {     /* for all L */
	double eps = *eps2;
	double xc, sqxc;

	if(l < 100)
	      eps = *eps1;

	ax=1-2*MOD(l,2);
	start_ll(*Jmx,*Lmx,l,abc,cc, acL, &cll);

	for (ix=0; ix<Kx; ix++)  { /* for all x(ix) */
	    int Km;
	    xc=x[ix];
	    sqxc=sqx[ix];

	    if(Ksym > 0)
		jx= nx1-ix;
	    if(jx <= ix)  jx = -100;

	    lgndr_0(*Jmx,*Lmx,xc,cc);

	    /* P_L^m,0<m<Km-1 */
	    lgndr_Ln(*Jmx,*Lmx,l,xc,sqxc,abc,cc,glm, &cll,NTml);

	    Km = Mmax[ix]+1;
	    if(l < Mmax[ix]) Km=l+1;

	    if(*K_temp > 0)
		  map_TL(Nmx,Nmp,Jmx,l,Km,
			 &eps,ix,jx,mb,f,glm,apm,bpm,NTeps);

	    if(*K_pol > 0) {
	       int aax=ax;
	       Pll_n(*Jmx,Km,l,cpL,aax,xc,sqxc,glm,Kxf,xlbd,NPml);
	       aax = -ax;
	       PL_map(Nmx,Nmp,Jmx,&L1,&Km,l,ix,jx,&aax,xlbd,
		     NPeps,&eps,mb,Q,U,qc,qs,uc,us);
	    }         /* K_pol>1    */
	}             /*  over ix   */
    }                 /* over all L */

    return;
}

void map_TL(Nmx,Nmp,Jmx,l, Km, eps,ix,jx,mb, f,glm,apm,bpm, Nt)
int *Nmx, *Nmp, *Jmx;
int l, ix, jx, mb, *Nt;
double *eps;
register double *f,*glm,*apm,*bpm;
{
    register int m1;
    int ax=1-2*MOD(l,2);
    int llp = l * *Nmp;
    register double *fr = f+llp, *fi = f+llp+mb;

    for(m1=1; m1<=Km; m1++) {
	register int m=m1-1;
	register int mm = m * *Nmx, mi = mm+ix, mj = mm+jx;
	register double gl = glm[m1];

	if(ABS(gl) > *eps) {
	    register double f_r = gl * *(fr+m), f_i = gl * *(fi+m);
	    (*Nt)++;
	    apm[mi] += f_r;
	    bpm[mi] += f_i;
	    if(jx > 0)  {       /* for symmetric x(ix)  */
		if (ax < 0) {
		    apm[mj] -= f_r;     /* proverit' znak u AG */
		    bpm[mj] -= f_i;
		} else {
		    apm[mj] += f_r;
		    bpm[mj] += f_i;
		}
	    }
	}              /* for glm< eps  */
	if(jx > 0) ax = -ax;
    }
    return;
}

void  PL_map(Nmx,Nmp,Jmx,L1, Km,l,ix,jx,ax, xlbd, Np, eps, mb,
		      Q,U,qc,qs,uc,us)
int *Nmx, *Nmp, *Jmx, *L1, *Km;
int l, mb, ix, jx, *ax, *Np;
double *eps;
double *Q, *U, *xlbd, *qc, *qs, *uc, *us;
{
    register int m1;
    int llp = l * *Nmp;
    int ll = *Jmx + 1;
    double *xi = xlbd + ll;

    for(m1= *L1; m1<= *Km; m1++) {   /* loop over L      */
	register int m=m1-1, Lb=mb+m;
	register double qr = Q[llp+m], qi = Q[llp+Lb],
			ur = U[llp+m], ui = U[llp+Lb];

	register double  fx = xlbd[m1];      /* F^m_L   */
	register double  px =  xi[m1];       /* Phi^m_L */

	if(ABS(fx) > *eps || ABS(px) > *eps) {
	    register int mm = m * *Nmx;
	    register int mmx = mm + ix;
	    qc[mmx] +=  fx * qr - px * ui;
	    qs[mmx] +=  fx * qi + px * ur;
	    uc[mmx] +=  px * qi + fx * ur;
	    us[mmx] += -px * qr + fx * ui;
	    if(jx > 0)  {
		  mmx = mm + jx;
		  if ( *ax < 0 )
		      px = -px;
		  else
		      fx = -fx;

		  qc[mmx] +=  fx * qr - px * ui;
		  qs[mmx] +=  fx * qi + px * ur;
		  uc[mmx] +=  px * qi + fx * ur;
		  us[mmx] += -px * qr + fx * ui;
	    }
	}
	*ax = -(*ax);
    }                          /* loop over L */
    return;
}
 

void sig_lgndr_Mu(Nmx,Nmp,Jmx,Lmn,Lmx,Ksym,eps1,eps2,
		      K_temp,Nx,x,sqx,Mmax,f,glm,xlbd,c,apm,bpm,
		      NTml,NTeps,NPml,NPeps,cpM,
		      Mlim,K_pol,Q,qc,qs,U,uc,us)
int *Nmx, *Nmp, *Jmx, *Lmn, *Lmx, *Ksym;
double *eps1, *eps2;
int *K_temp, *Nx, *Mmax;
double *x, *sqx, *f, *glm, *xlbd, *c, *apm, *bpm;
int *NTml, *NTeps, *NPml, *NPeps;
double *cpM;
int *Mlim, *K_pol;
double *Q, *qc, *qs, *U, *uc, *us;

{
    register int m, ix, jx;
    register int Kx = *Nx, nx1 = *Nx - 1;
    int mb = *Lmx+1;
    int Lb;
    double Enrm = pow(10., (double)*Mlim);
    register int mmb = *Jmx+2, mmb2=mmb+mmb;
    register double *cpmm = cpM + mmb;

    jx = -1;

    if(*Ksym > 0) Kx=(*Nx+1)/2;

    for(m=0; m<= *Lmx; m++) {       /* for all m */
       register int m1=m+1, mm = m * *Nmx;
       double eps = *eps2;
       double xc, cmm;
       int L0, sign, mv = m;

       if(m < 100) eps = *eps1;
       L0=m;
       if(L0 < *Lmn)  L0 = *Lmn;
       sign=1-2*MOD((L0+m),2);
       Lb = mb+m;

       start_clm(Lmx, &mv, &cmm,c);

       for(ix=0; ix<Kx; ix++) {         /* loop over x(ix) */
	    if (m <= Mmax[ix]) {
		if(*Ksym > 0) {
		   jx = nx1-ix;
		   if(jx <= ix) jx = -100;
		}
		xc = x[ix];
		lgndr_Mn(Mlim, &Enrm,Lmx,&mv,&cmm,c, &xc,glm,NTml);
		if(*K_temp > 0)
		    map_TM(*Nmx, *Nmp, *Jmx, *Lmx,L0,
			     NTeps, eps,m,ix,jx,Lb,f,glm,apm,bpm);
		if(*K_pol > 0) {
		    int ax = sign;
		    register int l, llp;
		    register double dfx=1./(1.-xc*xc + 1.e-20);
		    register double sx, sy, mdfx = m * dfx;

		    register int mi = mm + ix, mj = mm + jx;
		    register double *xr = xlbd + L0,
				    *xi = xlbd + L0 + *Jmx + 1;

		    llp= *Nmp * L0;

		    for (l=L0; l<= *Lmx; l++) {
			register int i=4*l-3, imm = i * mmb + m1;
			register double gl1 = glm[l+1], gl = glm[l],
					cgl = cpM[imm]*gl;
			register double *cpi = cpmm + imm;

			register double fx, px;

			sx = cgl*xc +   *cpi        * gl1;
			sx = sx*dfx -   *(cpi+mmb2) * gl1;  /* F_lm */
			sy = cgl  - xc* *(cpi+mmb)  * gl1;
			sy = mdfx * sy;                   /* Phi_lm */

			/* if(Kxf < 0) { */
			*xr = sx;              /* F_lm      */
			*xi = sy;              /* Phi_lm    */

			fx =  *xr + *xr;
			px =  *xi + *xi;
			if( ABS(fx) > eps || ABS(px) > eps) {
			    register int lr =llp+m, li=llp+Lb;
			    register double qr = Q[lr], qi=Q[li],
					    ur = U[lr], ui=U[li];

			    qc[mi] +=  fx * qr - px * ui,
			    qs[mi] +=  fx * qi + px * ur,
			    uc[mi] +=  px * qi + fx * ur,
			    us[mi] += -px * qr + fx * ui;

			    if(jx > 0) {
				if ( ax > 0 )
				      px = -px;
				else
				      fx = -fx;
				qc[mj] +=  fx * qr - px * ui,
				qs[mj] +=  fx * qi + px * ur,
				uc[mj] +=  px * qi + fx * ur,
				us[mj] += -px * qr + fx * ui;
			    }
			}
			ax = -ax;
			xr++, xi++;
			llp += *Nmp;
		    }
		}       /* for K_pol>0    */
	    }         /* for M<Mmax(ix) */
       }            /* loop over x    */
    }             /* loop over m    */

    return;
}
