#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define ABS(x) ((x) < 0 ? -(x) : (x))
#define MOD(x) (ABS(x))
#define SGN(x) (( (x) >=0 ) ? 1 : -1)
#define SQR(x) ((x)*(x))
#define PR     fprintf
#define ER     stderr

/* "Quicker-sort algorithm" from system library         */
int d_cmp(d1, d2)
int *d1, *d2;
{       
	return ( *d1 < *d2 ? -1 : (*d1 > *d2 ? 1 : 0));
}

double dsort_(d, n)
double *d;
int *n;
{
	register int k = *n, i = *n/2;
	qsort(d, k, sizeof(*d), (int (*)())d_cmp);
	return( (k&01)? d[i] : (d[i-1]+d[i])/2.);
}

static double *f_bp = (double *)0;
static int f_bsiz = 0;
static int f_bn = 0;

int dhlbeg_(n) /* beginning of row of estimations of sets of n elements */
int *n;
{       
	register int m = *n*(*n+1)>>1;
allbuf: 
	if(f_bp==(double *)0) {
		if( (f_bp = (double*)calloc(m,sizeof(*f_bp)))==(double*)0)
			return -1;
	} else if(f_bn < *n) {
		free(f_bp);
		f_bp = (double *)0;
		f_bn = 0;
		goto allbuf;
	}
	f_bsiz = m;
	return( f_bn = *n);
}

void dhlend_()       /* end of esimations row */
{
	if(f_bp!=(double *)0) {
		free(f_bp);
		f_bp = (double *)0;
		f_bn = 0;
	}
}

double drhodl_(farr)   /* estimation of queuing set */
double *farr;
{       
	register double *p11, *p22=(double *)0, *pb=f_bp;
	double *p1,*p2;
	double *pe=farr+f_bn;
	*pb++ = *farr;
	for(p2=farr+1; p2<pe; p2++)
		for(p1=p2-1; p1<=p2; p1++)
			for(p11=p1,p22=p2; (p11>=farr)&&(p22!=pe); )
				*pb++ = (((*p11--)-(*p22))/2.)+(*p22++);
	return(dsort_(f_bp, &f_bsiz));
}

