#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <math.h>

#define PR      fprintf
#define ER      stderr

extern void short_form(char *);

/* some variables */
extern char inp_file[161];  /* intput file for F(x,phi) or  a_{lm}    */
extern char outp_file[161]; /* output file for a_{lm} or F(x,phi)     */
extern int  calc_flag;      /* > 0,transforms a_lm to map, else back  */
extern int  calc_grid;      /* <0 - dx=2/(Nx-1), >0 - special grid    */
extern int  calc_number;    /* number of calculation                  */
extern int  num_x;          /* number of points along cos(theta)      */
extern int  num_phi;        /* number of points along phi             */
extern int  l_min;          /* Lmin                                   */
extern int  l_max;          /* Lmax                                   */
extern int  m_min;          /* Mmin                                   */
extern int  m_max;          /* Mmax                                   */
extern char file_C_l[161];  /* file with l, Cl tables                 */
extern char map_file[161];  /* file with map                          */
extern char file_alm[161];  /* file with alm tables                   */
extern int  random_seed;    /* input random seed                      */

/* some flags */
extern int alm_input;       /* flag to read  a_lm from file or str    */
extern int Cl_input;        /* flag showing reading Cl  from file     */
extern int map_input;       /* flag to read map from file             */
extern int legendre_calc_scheme;/* if flag=-1,then direct calcs,      */
				/* else from largest M to lower       */
extern int seed_flag;       /* flag to use user seed                  */

extern char *myname;

void read_pars_file(filename)
char *filename;
{
	register char *cs;
	register FILE *fp;
	register int i, c;
	int sep_s1 = '*',       /* separator 1 */
	    sep_s3 = ';',       /* separator 3 */
	    sep_s4 = ';',       /* separator 4 */
	    sep_m  = '=';
	int  l_calc = -1; /* index of input harmonique for f(x,phi) */
	int  m_calc = -1; /* index of input harmonique for f(x,phi) */

	char str[161], str1[121], buf[121], buf2[121];


	if ((fp = fopen(filename, "r")) == (FILE *)0) {
		PR(ER, "%s: can not open file '%s'\n", myname, filename);
		exit(2);
	}

	while (fgets(str, 160, fp) != NULL) {
		int st_len = strlen(str) - 1;

		/* miss empty or comments string */
		if ( *str == '#' ||  *str == '%' || *str == '\r'
		  || *str == '\n')
			continue;

		str[st_len] = '\0';  /* instead of '\n' */

		/* delete comments at the string's end */
		for(i=0; i < st_len; i++) {
			if ( str[i] == '#' ) {
				str[i] = '\0';
				st_len = i;
				break;
			}
			if (i > 0 && (str[i] == '-' || str[i] == '/') &&
			    (str[i-1] == ' ' || str[i-1] == '\t') &&
			    (str[i+1] == ' ' || str[i+1] == '\t') ){
				str[i] = '\0';
				st_len = i;
				break;
			}
		}

next_substring:
		/********************/
		/* miss ' ' symbols */
		/********************/

		/* from the begining */
		c = i = 0;
		while((str[i] == sep_s4 || str[i] == ' ' || str[i] == '\t')
		    && str[i] )   i++;
		while( (str[c] = str[i]) ) {
			c++;
			i++;
		}
		st_len = c;
		/* from the end */
		while( str[st_len] == ' ' || str[st_len] == '\t')
			st_len--;
		str [ ++st_len ] = '\0';

		/*---------------------------*/
		/* get string for operations */
		/*---------------------------*/
		i = 0;
		while((c=str1[i]=str[i]) != sep_s3 && c != sep_s4 && c)
			i++;
		if ( c )  str1[i] = '\0';


		/* continue loop */
		if ( !i )  /* empty string */
			continue;


		/* change main string */
		c = 0;
		while ( (str[c] = str[i]) ) {
			c++;
			i++;
		}

		/**************/
		/* operations */
		/**************/

		/* read parameters */

		cs = buf;
		i = 0;
		/* miss some symbols */
		while( (c=str1[i++]) == ' ' || c == '\t'
		    || c == '\r') ;
		i--;
		/* read 1st keyword till symbol 'sep_s1' or 'sep_m'*/
		while(((*cs++ =c=str1[i++])!=sep_s1&&c!=sep_m) && c);
		cs--;
		if ( *cs == '\0' )  c = -1;
		*cs = '\0'; /* delete symbol '*' at the buf end */

		if(c == -1) {
			;
		}
		/* save value of keywod to buf2 */
		/* and squeeze strings          */
		strcpy(buf2, str1+i);
		short_form(buf);
		short_form(buf2);

		/* upper letters instead of low */
		cs=buf; while(*cs) { *cs = toupper (*cs); cs++; }

		/*-------------------*/
		/* define what it is */
		/*-------------------*/
		switch(buf[0]) {
		case 'A':
			if (strcmp(buf, "ALM-FILE") == 0) {
				if (!alm_input) strcpy(file_alm, buf2);
				alm_input = -1;
			}
			break;
		case 'C':
			if (strcmp(buf, "CALCFLAG") == 0)
				calc_flag = atoi(buf2);
			else if (strcmp(buf, "CALCGR") == 0 ||
			      strcmp(buf, "CALC-GR") == 0)
				calc_grid = atoi(buf2);
			else if (strcmp(buf, "CALCNUM") == 0)
				calc_number = atoi(buf2);
			else if (strcmp(buf, "CL-FILE") == 0) {
				if (!Cl_input) strcpy(file_C_l, buf2);
				Cl_input = -1;
			}
			break;
		case 'D':
			if (strcmp(buf, "DL-FILE") == 0) {
				if (!Cl_input) strcpy(file_C_l, buf2);
				Cl_input = -2;
			}
			break;
		case 'I':
			if (strcmp(buf, "INPFILE") == 0)
				strcpy(inp_file, buf2);
			break;
		case 'L':
			if (strcmp(buf, "L-CALC") == 0)
				l_calc = atoi(buf2);
			else if (strcmp(buf, "L") == 0)
				l_calc = atoi(buf2);

			else if (strcmp(buf, "LMAX") == 0)
				l_max = atoi(buf2);
			else if (strcmp(buf, "LMIN") == 0)
				l_min = atoi(buf2);
			break;
		case 'M':
			if (strcmp(buf, "M-CALC") == 0)
				m_calc = atoi(buf2);
			else if (strcmp(buf, "M") == 0)
				m_calc = atoi(buf2);
			else if (strcmp(buf, "MMIN") == 0)
				m_min = atoi(buf2);

			else if (strcmp(buf, "MMAX") == 0)
				m_max = atoi(buf2);
			else if (strcmp(buf, "MAP-FILE") == 0) {
				if (!map_input) strcpy(map_file, buf2);
				map_input = -1;
			}
			break;
		case 'N':
			if (strcmp(buf, "NUM-X") == 0 ||
			    strcmp(buf, "NX") == 0 ) {
				if (num_x <= 0) num_x = atoi(buf2);
			} else if (strcmp(buf, "NUM-PHI") == 0 ||
			    strcmp(buf, "NPHI") == 0) {
				if (num_phi <= 0) num_phi = atoi(buf2);
			}
			break;
		case 'O':
			if (strcmp(buf, "OUTPFILE") == 0)
				strcpy(outp_file, buf2);
			break;
		case 'S':
			if (strcmp(buf, "SCHEME") == 0) {
				if( !legendre_calc_scheme )
					legendre_calc_scheme = atoi(buf2);
				if(*buf2 == 'L' || *buf2 == '1') {
					legendre_calc_scheme = 1;
				} else
					legendre_calc_scheme = -1;
			}
			break;
		case 'R':
			if (strcmp(buf, "RANDSEED") == 0) {
				random_seed = atoi(buf2);
				seed_flag = 1;
			}
			break;
		default :
			/* any other things */
			break;
		}
		goto next_substring;

	}

	fclose(fp);

	if (m_calc > 0) {
		m_min = m_max = m_calc;
	}
	if (l_calc > 0) {
		l_min = l_max = l_calc;
	}

	return;
}
