#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "glesp.h"

#define PR      fprintf
#define ER      stderr

#define MOD(a,p)   ((a) - (p) * (int)((a)/(p)))

extern void sig_lgndr_m_(int *, int *, int *, int *, int *, int *, int *,
	  int *,  double *,
	  int *, double *, double *, double *, double *, double *, double *);
extern void sig_lgndr_l_(int *, int *, int *, int *, int *, int *, int *,
	  double *,
	  int *, double *, double *, double *, double *, double *, double *);
extern void sig_dipole_(int *, int *, int *, int *, int *,
	  double *, double *, double *, double *);

extern void start_clm_(int *, int *, double *, double *);
extern void lgndr_m_(int *, int *, double *, double *, double *, double *);
extern void lgndr_0_(int *, double *, double *);
extern void lgndr_l_(int *, int *, double *, double *, double *);
extern void sig_phi_ (int *, int *, int *, int *, int *, double *,
		double *,double *,double *,double *,double *);
extern void sig_fast3_(int *, int *, int *, int *, int *, double *,
		double *,double *,double *,double *);

/*
 * -------------------------------------------------------------------- *
 C   input parameters: x(Nx) Nph(Nmx) - coordinates on
 C   the sphere, f(2:Lmx,1:Lmx+1) - real a_lm,
 C               f(2:Lmx,Lmx+2:2*Lmx+2) - imag a_lm,
 C   output parameter: f(Nmx,Nmp) signal in points x, phi
 * -------------------------------------------------------------------- *
 */
extern int max_double_();
void  signal_(Lmn,Lmx,Mmn,Mmx,Nx,eps,phi2, Nmx,Nmp, x,pw,f,Nph,
		wsave,cf,apm,bpm,  K_fast,Ksym,Kml)
int *Lmn, *Lmx, *Mmn, *Mmx, *Nx;
double *eps, *phi2;
int *Nmx, *Nmp;
double *x, *pw, *f;
int *Nph;
double *wsave, *cf;
double *apm, *bpm;
int *K_fast, *Ksym, *Kml;
{
	register int i, j, l, m, llp;
	double sq2   = M_SQRT2,         /* 1.41421356237309504880; */
	       sq_pi = 2./ M_2_SQRTPI;  /* = 1.772453851           */
	double cnorm = 1.;
//        double ss=0.0, sum=0.0;
	int i_dip_flag = 0, Lmx1= *Lmx + 1;
	_lmin_gl = max_double_();
	_enorm_gl = pow(10., (double)_lmin_gl);   /* 10^Lmin */

	/* set dipole */
	i_dip_flag = 0;
	if((*Kml == 0 || *Kml == 100) && *Lmx < 0) {
	    *Lmx = -(*Lmx);
	    Lmx1= *Lmx + 1;
	    if(*Kml == 100) {
		 *Kml = -1;
	    }
	    i_dip_flag = 1;
	}

	llp = *Nmp + *Nmp;
	for(l=2; l<= *Lmx; l++, llp+=*Nmp) {
	    f[llp] *= sq2;
/*
	    sum += f[LL]*f[LL];
*/
	    for (m=1; m<=l; m++) {
		   f[llp+m] += f[llp+m];
		   f[llp+m+ Lmx1] = -(f[llp+m+Lmx1]+f[llp+m+Lmx1]);
/*
		   sum += f[LL+m]*f[LL+m] + f[LL+ *Lmx+1+m]*f[LL+ *Lmx+1+m];
*/

	    }
	}
/*
PR(ER, "sum=%20.13e\n", sum);
*/
/*  It is produced by calloc
	for(m=0; m <= *Lmx; m++) {
		int mm = m * *Nmx;
		for(i=0; i< *Nmx; i++)  apm[mm+i]=bpm[mm+i]=0.;
	}
*/
	/*
	 *  set dipole
	 */
	if(i_dip_flag)
	     sig_dipole_(Nmx,Nmp, Lmx,Ksym, Nx,x,f,apm,bpm);

	/*---------------------------------------*/
	/* loop over l - SUM_l[a_{lm}P_l^m(x_p)] */
	/*---------------------------------------*/
	if ( *Kml < 0)  {
/*
	    PR(ER, "sig-lgndr_M: Kml=%d, Kfast=%d, Ksym=%d\n",
		*Kml, *K_fast, *Ksym);
*/
	    sig_lgndr_m_(Nmx,Nmp,Nph,Lmn,Lmx, Mmn, Mmx,
		     Ksym,eps,Nx,x,f,cf,wsave,apm,bpm);
	}

	if( *Kml > 0) {
/*
	    PR(ER, "sig-lgndr_L: Kml=%d, Kfast=%d, Ksym=%d\n",
		*Kml, *K_fast, *Ksym);
*/
	    sig_lgndr_l_(Nmx,Nmp,Lmn,Lmx, Mmn, Mmx,
	       Ksym,eps,Nx,x,f,cf,wsave,apm,bpm);
	}
	for(m=i=0; i< *Nmx; i++, m+=*Nmp) {
	     for(j=0; j < *Nmp; j++)  f[m+j]=0;
	}

	/*----------------------------------------*/
	/* loop over m - SUM_m[a_{lm}e^{i m phi}] */
	/*----------------------------------------*/
	if(*K_fast < 0)
	     sig_phi_(Nmx,Nmp, Lmx, Nx,Nph,cf,phi2,apm,bpm,wsave,f);

	if(*K_fast > 0)
	     sig_fast3_(Nmx,Nmp, Lmx, Nx,Nph,apm,bpm,cf,f,wsave);

	/*--------------------------------------*/
	/* renormalization and test of integral */
	/*--------------------------------------*/
	cnorm /= sq_pi;         /* factor 2 due to m & -m  */
	cnorm /= sq2;


//      ss=sum=0.0;
	for(m=i=0; i < *Nx; i++, m+=*Nmp)  {
	    int n = Nph[i];
	    for(j=0; j<n; j++) {
//                double v;
		  f[m+j] *= cnorm;        /* here f(i,j) is the map */
//                v = f[m+j]; v *= v;
//                sum += v / Nph[i];
//                ss  += v * pw[i];
	    }
	}
//PR(ER, "sum f**2=%15.8e, summ=%15.8e, Nx=%d\n", 2*ss, sum, *Nx);

	return;
}

/*
*   loop over l - SUM_l[a_{lm}P_l^m(x_p)]
*    input: f(i,j)=alm, x(ix)
*   output: apm,bpm (m,ix)
*
*     DIMENSION x(Nx),f(Nmx*Nmp)
*     DIMENSION c(2*Lmx+1),glm(Lmx+1)
*     DIMENSION apm((Jmx+1)*Nmx),bpm((Jmx+1)*Nmx)
*/
void sig_lgndr_m_(Nmx,Nmp,Nph,Lmn,Lmx,Mmn,Mmx,Ksym, eps,Nx,x,f,glm,c,apm,bpm)
int *Nmx, *Nmp, *Nph;
int *Lmn, *Lmx, *Mmn, *Mmx;
int *Ksym;
double *eps;
int *Nx;
double *x, *f;
double *glm, *c, *apm, *bpm;
{
	register int l, m, ix, jx=0;
/*
	double sum_a=0.0, sum_b=0.0;
*/
	int Kx = *Nx;
	int Lmx1 = *Lmx + 1;
	double cmm;
	int mmin= (*Mmn <  0 ? 0 : *Mmn),      /*               */
	    mmax= (*Mmx < 0 ? *Lmx : *Mmx);   /* use in future */
	register  int mm = mmin * *Nmx, nx1 = *Nx - 1;
	double vnyq = 0.5;
	register int *mx = (int *)0;

	if(*Ksym > 0)  Kx = (*Nx+1)/2;

	if ((mx = (int *)calloc((unsigned)Kx, sizeof *mx)) == (int *)0) {
	    PR(ER, "alm_lgndr_m_: no memory...\n");
	    exit(1);
	}
	for(ix=0; ix<Kx; ix++) {
	    mx[ix] = vnyq * Nph[ix];
	    if (mx[ix] > *Lmx) mx[ix] = *Lmx;
	}

	for (m=mmin; m <= mmax; m++,mm+=*Nmx) {  /* for all m */
	   int mv = m, ax, sign, L0;
	   register double *f_r = f + m, *f_i = f + m + Lmx1;

	   L0=m;
	   if(L0 < *Lmn)  L0 = *Lmn;
	   sign = 1 - 2* MOD(L0+m,2);

	   start_clm_(Lmx, &mv, &cmm, c);

	   for (ix=0; ix < Kx; ix++) {  /* loop over x(ix) */
		register int mi = mm+ix, mj=0;
		double xc = x[ix];
		register int llp;
		register double a_n = 0.0, a_s = 0.0,
				b_n = 0.0, b_s = 0.0;

		if (m > mx[ix])  continue;

		lgndr_m_(Lmx, &mv, &cmm, c, &xc, glm);

		if(Kx < *Nx) {   /* for symmetric x */
		    jx = nx1 - ix;
		    if(jx <= ix) jx = -100;
		    else  mj = mm + jx;
		} else jx = -100;

		llp = *Nmp * L0;
		ax = sign;
		for (l=L0; l<= *Lmx; l++,llp+=*Nmp) { /* loop over L */
		    register double gl = glm[l+1];
		    if(ABS(gl) > *eps) {
			register double  ag = gl * f_r[llp];
			register double  bg = gl * f_i[llp];
			a_n += ag;
			b_n -= bg;
			if(jx > 0) {
			    if (ax<0) {
				a_s -= ag;
				b_s += bg;
			    } else {
				a_s += ag;
				b_s -= bg;
			    }
			}          /*  for symmetric x     */
		    }            /*  for glm< eps        */
		    ax = -ax;
		}              /*  end of loop over L  */

		*(apm + mi) += a_n;
		*(bpm + mi) += b_n;
		if(jx != -100) {
		    *(apm + mj) += a_s;
		    *(bpm + mj) += b_s;
		}
		/* test for sum_a, sum_b */
/*
		sum_a += apm[mm+ix]*apm[mm+ix];
		sum_b += bpm[mm+ix]*bpm[mm+ix];
		if(Kx < *Nx) {
		    jx = *Nx-ix-1;
		    if(ix < jx) {
			sum_a += apm[mm+jx]*apm[mm+jx];
			sum_b += bpm[mm+jx]*bpm[mm+jx];
		    }
		}
*/
	    }                /* loop over x     */
	}                  /* loop over m     */

/*
PR(ER, "sum_a_M=%20.13e,  sum_b_M=%20.13e\n", sum_a, sum_b);
*/
	if (mx != (int *)0)  free((void *)mx);

	return;
}

/*
*   loop over l - SUM_l[a_{lm}P_l^m(x_p)]
*    input: f(i,j)=alm, x(ix)
*   output: apm,bpm (m,ix)
*
*     DIMENSION x(Nx),f(Nmx*Nmp)
*     DIMENSION apm((Jmx+1)*Nmx),bpm((Jmx+1)*Nmx)
*     DIMENSION abc(4*Lmx),glm(2*Lmx+1)
*/
void sig_lgndr_l_(Nmx,Nmp,Lmn,Lmx,Mmn,Mmx,Ksym,
		    eps,Nx,x,f,glm,abc,apm,bpm)
int *Nmx, *Nmp;
int *Lmn, *Lmx, *Mmn, *Mmx, *Ksym;
int *Nx;
double *eps, *x, *f, *glm, *abc, *apm, *bpm;
{
	register int ix, l, m;
/*
	double sum_a=0.0, sum_b=0.0;
*/
	int  ax=0;
	int mmin= (*Mmn < 0 ? 0 : *Mmn),      /*               */
	    mmax= (*Mmx < 0 ? *Lmx : *Mmx);   /* use in future */
	register int Lmx1 = *Lmx + 1;
	int Kx = *Nx, nx1 = *Nx - 1;

	if( *Ksym > 0) Kx = (*Nx+1)/2;  /* for symmetric x */
	for(ix=0; ix<Kx; ix++)  { /* integral over x(ix) */
	    double xc=x[ix];
	    register int llp = *Lmn * *Nmp;

	    lgndr_0_(Lmx,&xc,glm);  /*  P_L^0(ix),L<Lmx  */

	    for(l = *Lmn; l <= *Lmx; l++, llp+=*Nmp) { /* for all L  */
		/* for m=0 */
		int lv=l;
		register double gl = glm[Lmx1+l];
		int mmn=mmin, mmx = mmax;
		register int mm;

		if (mmin == 0) {
		    if(ABS(gl) > *eps)  {
			apm[ix] += gl*f[llp];
			bpm[ix] -= gl*f[llp+Lmx1];
			if(Kx < *Nx) {      /* for symmetric x(ix) */
			    int jx = nx1-ix;
			    if(jx > ix) {
				ax = 1- 2* MOD(l,2);
				if (ax < 0) {
				    apm[jx] -= gl*f[llp];
				    bpm[jx] += gl*f[llp+Lmx1];
				} else {
				    apm[jx] += gl*f[llp];
				    bpm[jx] -= gl*f[llp+Lmx1];
				}
			    }
			}
		    }       /*  for glm< eps */
		}
		lgndr_l_(Lmx, &lv, &xc, abc, glm); /* P_L^m(ix),1<m<L */

		if (mmn <= 1)  mmn = 1;
		if (mmx >  l)  mmx = l;

		for(m=mmn, mm=*Nmx*m; m<=mmx; m++,m+=*Nmx) {
		    gl = glm[m];
		    if(fabs(gl) > *eps) {
			apm[mm+ix] += gl*f[llp+m];
			bpm[mm+ix] -= gl*f[llp+Lmx1+m];
			if(Kx < *Nx) {  /* for symmetric x(ix) */
			    int jx = nx1-ix;
			    if(jx > ix) {
				ax= 1 - 2 * MOD((l+m),2);
				if (ax < 0) {
				    apm[mm+jx] -= gl*f[llp+m];
				    bpm[mm+jx] += gl*f[llp+Lmx1+m];
				} else {
				    apm[mm+jx] += gl*f[llp+m];
				    bpm[mm+jx] -= gl*f[llp+Lmx1+m];
				}
			    }
			}
		    }                 /* for glm< eps    */
		}                  /* over all 1<m<L  */
	    }                   /* over all L      */

/*
	    for(m=0; m <= *Lmx; m++) { \* test for sum *\
		int mm  = m * *Nmx;
		int mix = mm + ix;
		sum_a += apm[mix]*apm[mix];
		sum_b += bpm[mix]*bpm[mix];
		if(Kx < *Nx) {            \* for symmetric x(ix) *\
		  int mjx = mm + *Nx-ix-1;
		  if(mjx > mix) {
			sum_a += apm[mjx]*apm[mjx];
			sum_b += bpm[mjx]*bpm[mjx];
		  }
		}
	    }
*/
	}                               /* end for x(ix) */
/*
PR(ER, "sum_a_M=%15.8e,  sum_b_M=%15.8e\n", sum_a, sum_b);
*/
	return;
}

void sig_dipole_(Nmx,Nmp, Lmx, Ksym, Nx,x,f,apm,bpm)
int *Nmx, *Nmp, *Lmx;
int *Ksym;
int *Nx;
double *x, *f, *apm, *bpm;
{
      register int ix, jx;
      int Kx = *Nx;
      int mb = *Lmx+2;
      double cnorm = sqrt(3.);
      int L1 = *Nmp, nx1 = *Nx - 1;

      if(*Ksym > 0)  Kx = (*Nx+1)/2;

      for(ix=0; ix<Kx; ix++) {  /* loop over x(ix) */
	   double xc = -sqrt(1.-x[ix]*x[ix]);
	   xc *= cnorm;

	   apm[ix] += x[ix]*f[L1] * cnorm;
	   apm[*Nmx+ix] += xc*f[L1+1];
	   bpm[*Nmx+ix] += xc*f[L1+mb];

	   if(Kx < *Nx) {  /*   for symmetric x    */
		jx = nx1-ix;
		if(ix < jx) {
		    apm[jx] -= x[ix]*f[L1] * cnorm;
		    apm[*Nmx+jx] += xc*f[L1+1];
		    bpm[*Nmx+jx] += xc*f[L1+mb];
		}
	   }            /* for symmetric x  */
      }                 /* loop over x      */

//     PR(ER, "dipole calculation is done\n");

      return;
}


void sig_dipole_T(Nmx, nbuf, Lmx, Ksym, Nx,x, alm,apm,bpm)
int Nmx, nbuf, Lmx;
int Ksym;
int Nx;
double *x, *alm, *apm, *bpm;
{
      register int ix, jx;
      int Kx = Nx;
      int mb = (Lmx+2) * nbuf;
      double cnorm = sqrt(3.) / 2.;
      int nx1 = Nx - 1;
      double a_10  = alm[1] * sqrt(2.),
	     a_11r = alm[nbuf+1],
	     a_11i = alm[mb+1];

      if(Ksym > 0)  Kx = (Nx+1)/2;

      for(ix=0; ix<Kx; ix++) {  /* loop over x(ix) */
	   double xc = -sqrt(1.-x[ix]*x[ix]);
	   xc *= cnorm;

	   apm[ix] += x[ix] * a_10 * cnorm;
	   apm[Nmx+ix] += xc * a_11r;
	   bpm[Nmx+ix] += xc * a_11i;

	   if(Kx < Nx) {  /*   for symmetric x    */
		jx = nx1-ix;
		if(ix < jx) {
		    apm[jx] -= x[ix] * a_10 * cnorm;
		    apm[Nmx+jx] += xc * a_11r;
		    bpm[Nmx+jx] += xc * a_11i;
		}
	   }            /* for symmetric x  */
      }                 /* loop over x      */

//    PR(ER, "dipole calculation is done\n");

      return;
}


