#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>

#define PR      fprintf
#define ER      stderr

#ifdef   sun
#define  MAX_RAND   2147483647.
#define  MAX_RAND1  4294967295.
#else
#define  MAX_RAND   32767.
#endif

#ifdef __GNUC__
#undef   MAX_RAND
#define  MAX_RAND   RAND_MAX
#endif

int seed_flag = 0, random_seed=0;
extern void setopt(int, char **), usage(void);
extern void phase_rand(double *, int);
extern int  init_rand(void);
extern void u_rand(double *, unsigned int, double, double);

char *myname="sinsum";

int main(argc, argv)
int argc;
char **argv;
{
	register int l, m;
	double *phase, pi2 = 2 * M_PI, shift = 0.;
	int lmax = 100;

	/* loop over external parameters */
	setopt(argc, argv);

	init_rand();

	if((phase = (double *)calloc(lmax+2, sizeof *phase)) == (double *)0) {
	    PR(ER,"%s: no memory for array...\n");
	    exit(1);
	}
	for(l=2; l<=lmax; l++) {
	    double s;
	    u_rand(phase, (unsigned)l, pi2, shift);
	    phase[0] = s = 0.0;
	    for(m=0; m<=l; m++) {double ss=sin(phase[m]); s += ss*ss; }
	    PR(ER, "%4d %12.5e %12.5e\n", l, s, s/l);
	}
	exit(0);
}

void setopt(argc, argv)
int argc;
char **argv;
{
    register int i;
    myname = argv[0];

    for(i=1; i<argc; i++) {
	switch(argv[i][0]) {
	case '-':
		switch(argv[i][1]) {
		case 'h':
			usage();
			break;
		default:
			break;
		}
		break;
	case '+':
		switch(argv[i][1]) {
		case 'h':
		default:
			usage();
			break;
		}
		break;
	default:
		usage();
		break;
	}
    }

    return;
}

void usage()
{
PR(ER, "usage: %s\n", myname);
exit(2);
}

void phase_rand(phase, n)
double *phase;
int n;
{
	double pi2 = 2 * M_PI, shift = 0.;

	if ( seed_flag ) {
	      /* start random generator using system time */
	      srand(random_seed);
	} else {
	      init_rand();
	}

	u_rand(phase, n, pi2, shift);

	return;
}
/*
 * init_rand() initiates random sequence by time point
 * and returns seed
 */
int init_rand()
{
	int start_point;
	long time(),tm;
	start_point = (long)((double)time(&tm) - 660912760.0) % 660912760l;
	srand(start_point);
	return start_point;
}
void u_rand(noise,n,lev, shift)
double *noise;
double lev, shift;
unsigned int n;
{
	register unsigned int j;

	for(j=0 ; j < n ; j++ )
		noise[j] = lev * ((double)rand() / MAX_RAND - shift);
}
