#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <math.h>

#include "glespol.h"
#define PR  fprintf
#define ER  stderr

extern void signal_Pol(int *, int *, int *, int *, int *,
	int *, int *, int *, int *,
	int *, double *, double *, double *, double *, int *,
	double *, int *,
	double *,double *,double *,double *,double *,double *,
	double *,double *,
	int *, int *, double *,double *,double *,double *,
	double *,double *,double *,double *,double *,double *,double *);


extern int legendre_calc_scheme; /* if flag=-1, then direct calculations, */
				 /* else from largest M to lower          */
extern int max_double_();

/* calculation of Q & U maps */
int sp2qu_n(f, q, u, x, pw, pqu, nx, np, nph,
		alm, s_alm, p_alm, lmin, lmax, nbuf, eps1, eps2, Mmax)
double *f, *q, *u, *x, *pw, *pqu;
int nx, np, *nph;
double *alm, *s_alm, *p_alm;
int lmin, lmax, nbuf;
double eps1, eps2;
int *Mmax;
{
    int Nmx=nx, Jmx=(Nmx+1)/2;
    int Nmp = np;
    register int l, m;
    int
	Ksym      = 1,
	Ksml      = legendre_calc_scheme==0 ? -1 : legendre_calc_scheme,
	K_pol     = (q != NULL || u != NULL ? 1 : -1),
	K_temp    = (f != NULL ? 1 : -1),
	Ktst    = 1;
    int Lmn= lmin < 1 ? 1 : lmin, Lmx=lmax, Lmx1=lmax+1, Nx = nx;
    int *Nph = nph;
    double *wsave = (double *)0, *cf = (double *)0;
    double
	   *xlbd = (double *)0;
    double *apm = (double *)0, *bpm = (double *)0,
	   *qc = (double *)0, *qs = (double *)0,
	   *uc = (double *)0, *us = (double *)0;
    double *cpM = (double *)0, *cpL = (double *)0, *acL = (double *)0,
	   *abc = (double *)0, *cc  = (double *)0, *glm, *c,
	   *sqx  = (double *)0;
    int Mlim = max_double_();
    static int mem_flag = -1;

    if ((wsave=(double *)calloc((2*Nmp+15), sizeof *wsave))==(double *)0) {
nomem:
	if (wsave != (double *)0)  free((void *)wsave);
	if (cf   != (double *)0)   free((void *)cf);
	if (xlbd != (double *)0)   free((void *)xlbd);
	if (qc   != (double *)0)   free((void *)qc);
	if (qs   != (double *)0)   free((void *)qs);
	if (uc   != (double *)0)   free((void *)uc);
	if (us   != (double *)0)   free((void *)us);
	if (apm  != (double *)0)   free((void *)apm);
	if (bpm  != (double *)0)   free((void *)bpm);
	if (cpM  != (double *)0)   free((void *)cpM);
	if (cpL  != (double *)0)   free((void *)cpL);
	if (acL  != (double *)0)   free((void *)acL);
	if (abc  != (double *)0)   free((void *)abc);
	if (cc   != (double *)0)   free((void *)cc);
	if (sqx  != (double *)0)   free((void *)sqx);

	mem_flag -= 1;
	return mem_flag+1;
    }
    if((cf = (double*)calloc(Nmp, sizeof *cf)) == (double *)0) goto nomem;
    if((xlbd=(double*)calloc(2*Nmx+3,sizeof *xlbd))==(double*)0) goto nomem;
    if (q != (double *)0) {
	if((qc=(double*)calloc(Nmx*(Jmx+1),sizeof *qc))==(double*)0)
	    goto nomem;
	if((qs=(double*)calloc(Nmx*(Jmx+1),sizeof *qs))==(double*)0)
	    goto nomem;
	if((uc=(double*)calloc(Nmx*(Jmx+1),sizeof *uc))==(double*)0)
	    goto nomem;
	if((us=(double*)calloc(Nmx*(Jmx+1),sizeof *us))==(double*)0)
	    goto nomem;
    }
    if (f != (double *)0) {
	if((apm=(double*)calloc(Nmx*(Jmx+1),sizeof *apm))==(double*)0)
	    goto nomem;
	if((bpm=(double*)calloc(Nmx*(Jmx+1),sizeof *bpm))==(double*)0)
	    goto nomem;
    }
    l = (4*Jmx) * (Jmx+2);
    if ((cpM =(double *)calloc(l, sizeof *cpM)) == (double *)0) goto nomem;
    l = (3*Jmx) * (Jmx+1);
    if ((cpL =(double *)calloc(l, sizeof *cpL)) == (double *)0) goto nomem;
    l = (2*Jmx) * (Jmx+1);
    if ((acL =(double *)calloc(l, sizeof *acL)) == (double *)0) goto nomem;
    if ((abc =(double *)calloc(4*Jmx, sizeof *abc)) ==(double*)0) goto nomem;
    if ((cc =(double *)calloc(4*Jmx+4, sizeof *cc)) ==(double*)0) goto nomem;
    glm = wsave;
    c = wsave + 3 * Jmx + 6;
    if((sqx = (double *)calloc(Nmx, sizeof *sqx)) == (double *)0) goto nomem;

    for(l=0; l<=lmax; l++)  {
	for(m=0; m<=l; m++) {
	    register int  lmr  = l + nbuf * m,
			  lmi  = l + nbuf * (m + Lmx1);
	    /* and put minus */
	    if (q != (double *)0) {
		   s_alm[lmr] = -s_alm[lmr];  s_alm[lmi] = -s_alm[lmi];
		   p_alm[lmr] = -p_alm[lmr];  p_alm[lmi] = -p_alm[lmi];
	    }
	}
    }

    if(K_pol > 0) {
	int Kstr = Ksml;
	extern void norma_M(), norma_L(), start_Labc();
	if(Kstr < 0)  norma_M(&Jmx,&Lmn,&Lmx,cpL,cpM);
	if(Kstr > 0)  {
	    start_Labc(Jmx,Lmx,Lmn,acL);
	    norma_L(&Jmx,&Lmn,&Lmx,cpL,cpM);
	}
    }
    if (Ksml > 0) {
	for(l=0; l<Nx; l++)
	    sqx[l] = sqrt(1.0-x[l]*x[l]+1.e-50);
    }
    signal_Pol(&Nmx,&Nmp,&Jmx,&Lmn,&Lmx,&Nx,&Ksym,&Ksml,&Ktst,
	       &K_temp,&eps1,&eps2,x,sqx,Mmax, f,Nph,
	       glm, wsave,c, abc, cc, cf,apm,bpm,
	       &Mlim, &K_pol, cpL, cpM, acL, pqu, q,u,qc,uc,qs,us, xlbd);

    if(wsave != (double *)0)    free((void *)wsave);
    if(cf    != (double *)0)    free((void *)cf);
    if(xlbd  != (double *)0)    free((void *)xlbd);
    if(apm   != (double *)0)    free((void *)apm);
    if(bpm   != (double *)0)    free((void *)bpm);
    if(qc    != (double *)0)    free((void *)qc);
    if(qs    != (double *)0)    free((void *)qs);
    if(uc    != (double *)0)    free((void *)uc);
    if(us    != (double *)0)    free((void *)us);

    if(cpM   != (double *)0)    free((void *)cpM);
    if(cpL   != (double *)0)    free((void *)cpL);
    if(acL   != (double *)0)    free((void *)acL);
    if(abc   != (double *)0)    free((void *)abc);
    if(cc    != (double *)0)    free((void *)cc);
    if(sqx   != (double *)0)    free((void *)sqx);

    return 0;
}
