#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>

#include "glesp.h"

#define PR      fprintf
#define ER      stderr

/*
 *   calculation of function I(l,m,l',m') = Sum w_p * F(l,m,p) * F(l',m',p)
 *   VO, 28/03/2002
 *  modified 12/12/2004
 */

/*
#define LMX     89
*/
#define LMX     40              /* Lmax - maximum L */
//#define NMX     (2*(LMX+1))
#define NMX     103             /* number of rings  */
#define NMPHI   (2*NMX)
int  n_inp_iter = 1;
int l_inp = -1,
    m_inp = -1,
    lp_inp = -1,
    mp_inp = -1;
int hp_grid = 0;
int lmax=100, nx=0, nphi=0, lmax_print= -1;
double th0=0, th1=M_PI;
char alm_file[161];

extern void setopt(int, char **), usage(void);
extern void lgndr_m_(int *, int *, double *, double *, double *, double *);

char *myname="test_flp";

int main(argc, argv)
int argc;
char **argv;
{
    register int i, l, m, lp, mp;
    double pf[LMX+1][LMX+1][LMX+1];
    double a[LMX+1][LMX+1][LMX+1];
    double f_lm[NMX][LMX+1][LMX+1];
    double x[NMX], w[NMX];
    int nph[NMX];
    double cf[NMPHI];
    int nx0 = -1, nx1 = -1;;
    int n_iter, iter;
    double *alm = (double *)0, *alm1 = (double *)0;
    int lmx1, nalm, nbuf;
    FILE *fp_out = stdout;

PR(ER, "start...\n");
    /* make value zero */
    for(m=0; m<=LMX; m++) {
	for(l=0; l<=LMX; l++) {
	    for(i=0; i<NMX; i++)  f_lm[i][m][l] = 0.0;
		for(mp=0; mp<=LMX; mp++)
		    pf[l][m][mp] = 0.0;
	}
    }
    alm_file[0] ='\0';

    /* loop over external parameters */
    setopt(argc, argv);
    n_iter = n_inp_iter;

    read_alm_table(alm_file, &alm, &nalm, &nbuf, &lmx1);
    lmax = lmax_print > lmx1 ? lmax_print : lmx1;
/*
{
for(l=0; l<=3; l++) {
for(m=0; m<=l; m++) {
PR(ER, "%4d %4d %12.5e %12.5e\n", l,m,alm[l*nbuf+m], alm[l*nbuf+m+lmax+1]);
}}
}
*/
    alm1 = (double *)calloc(nbuf*(lmax+1), sizeof *alm1);
    if (alm1 == (double *)0) {
	PR(ER, "no memory...\n");
	exit(1);
    }

    if (lmax > LMX)  lmax = LMX;
    if (nx   > NMX)  nx = NMX;
/*
PR(ER,"l_fixed = %d, m_fixed = %d, lp_fixed = %d, mp_fixed = %d, lmax = %d\n",
l_inp, m_inp, lp_inp, mp_inp, lmax);
*/
/*
    if ((lp_inp < 0 || mp_inp < 0) && (l_inp  < 0 || m_inp  < 0) &&
	(m_inp  < 0 || mp_inp < 0) && (l_inp  < 0 || lp_inp < 0) ) {
	      PR(ER,"%s: set pair of input multipoles...\n", myname);
	      usage();
    }
*/

    /* higher lmax & nx */
    if (nx < 1)   nx = 2 * (lmax+1);
    if (nphi < 1) nphi = 2 * nx;
PR(ER, "nx=%d, nphi=%d\n", nx, nphi);
    /* coordinates and weights */
    coord(1, -10, -1., 1., 2*M_PI, x, w, nx, nph, nphi);

    if (th0 > -100.) {
PR(ER, "th0=%g(%g degs)\n", th0, th0*180/M_PI);
	nx0 = ind_x(nx, x, cos(M_PI/2+th0));
	nx1 = ind_x(nx, x, cos(M_PI/2-th0));
	if (nx0 > nx1) {i=nx0; nx0 = nx1; nx1=i;}
    }


    /* Legendre polynomials calculations */
    for(m=0; m<=lmax; m++) {
	    int mv = m;
	    double cmm;
	    start_clm_(&lmax, &mv, &cmm, cf);

	    for(i=0; i<nx; i++) {
		    double xc = x[i];
		    double *glm = &f_lm[i][m][0];
		    lgndr_m_(&lmax, &mv, &cmm, cf, &xc, glm);
	    }
    }
    /* calculate A-matrix */
    for(l=2; l<=lmax; l++) {
	for(m=0; m<=l; m++) {
	    double g1 = lgamma((double)(l-m+1)),
		   g3 = lgamma((double)(l+m+1));
	    for(lp=2; lp<=lmax; lp++) {
		if (lp < m) continue;
		double g2 = lgamma((double)(lp-m+1)),
		       g4 = lgamma((double)(lp+m+1));
		a[l][lp][m] = sqrt((2*l+1.)*(2*lp+1))/(4*M_PI) *
		    sqrt(exp(g1-g3 + g2-g4));
	    }
	}
    }

PR(ER, "nx0=%d, nx1=%d, number of iterations=%d\n", nx0, nx1, n_iter);
    if (nx0 < 0)  nx0=0;
    if (nx1 > nx) nx1=nx;

    for(i=0; i<nx; i++)  {
	double dx;
	if (i < nx0)  continue;
	if (i > nx1)  break;

	if (i< 1) dx = x[1]-x[0];
	else if (i > nx-2) dx = x[nx-1]-x[nx-2];
	else dx = x[i]-x[i-1];

	dx = -dx;

	for(l=2; l<=lmax; l++) {
	    int m0 = m_inp >= 0 ? m_inp : 0;
	    int ml = m_inp >= 0 ? m_inp : l;
	    for(m=m0; m<=ml; m++) {
//                double cf_l = sqrt((2*l+1.)/2 *
//                        exp(lgamma((double)(l-m))-lgamma((double)(l+m))) );
		for(lp=2; lp<=lmax; lp++) {
		    if (lp < m) continue;
//                    double cf_lp = sqrt((2*lp+1.)/2 *
//                        exp(lgamma((double)(lp-m))-lgamma((double)(lp+m))) );
		    mp=m;
		    pf[l][lp][m] +=
			   dx*f_lm[i][m][l]*f_lm[i][mp][lp];
//                            dx*f_lm[i][m][l]*f_lm[i][mp][lp]/cf_l/cf_lp;
		}
	    }
	}
    }

    for(iter=0; iter<n_iter; iter++) {
PR(ER, "iteration = %d\n", iter);

/*
	PR(ER, "m_inp=%d\n", m_inp);
	m = m_inp;
	for(l=2; l<=lmax; l++) {
		for(lp=2; lp<=lmax; lp++) {
		    printf(" %5d  %5d  %14.7e  %14.7e  %14.7e\n",
			l,lp,pf[l][lp][m],a[l][lp][m],pf[l][lp][m]*a[l][lp][m]);
		}
	}
*/

	for(l=2; l<=lmax; l++) {
	    int ll = l * nbuf;
	    int m0 = m_inp >= 0 ? m_inp : 0;
	    int ml = m_inp >= 0 ? m_inp : l;
	    double s=0.0;
	    for(m=m0; m<=ml; m++) {
		for(lp=2; lp<=lmax; lp++) {
		    int llp = lp * nbuf;
		    if (lp < m) continue;
//                    s = pf[l][lp][m]*a[l][lp][m];
		    s = pf[l][lp][m];

//                    s = -s;
//                    if ( (iter+1)%2 ) s = -s;
/*
PR(ER, "%d %d %d p=%g, a=%g, s=%g\n", l,m,lp,pf[l][lp][m],a[l][lp][m],s);
*/
		    alm1[ll+m]        += s * alm[llp+m]        ;
		    alm1[ll+m+lmax+1] += s * alm[llp+m+lmax+1] ;
		}
	    }
	}
	for(l=2; l<=lmax; l++) {
	    int ll = l * nbuf;
	    for(m=0; m<=l; m++) {
		alm[ll+m]        += alm1[ll+m];
		alm[ll+m+lmax+1] += alm1[ll+m+lmax+1];
if(iter!=n_iter-1)    alm1[ll+m] = alm1[ll+m+lmax+1] = 0.0;
	    }
	}
    }
    for(l=2; l<=lmax; l++) {
	int ll = l * nbuf;
	for(m=0; m<=l; m++) {
	    PR(fp_out, "%4d %4d  %15.8e %15.8e\n",
		    l, m,
		alm[ll+m], alm[ll+m+lmax+1]);
//              alm1[ll+m], alm1[ll+m+lmax+1]);
	}
    }
    exit(0);
}

void setopt(argc, argv)
int argc;
char **argv;
{
    register int i;
    char s1[30], s2[30];
    myname = argv[0];

    for(i=1; i<argc; i++) {
	switch(argv[i][0]) {
	case '-':
		switch(argv[i][1]) {
		case 'a':
			strcpy(alm_file, argv[++i]);
			break;
		case 'l':
			if (strncmp(argv[i]+1, "lma", 3) == 0) {
			     lmax  = atoi(argv[++i]);
			} else if (strncmp(argv[i]+1, "lp", 2) == 0) {
			     lp_inp = atoi(argv[++i]);
			} else {
			     l_inp = atoi(argv[++i]);
			}
			break;
		case 'm':
			if (strncmp(argv[i]+1, "mp", 2) == 0) {
			     mp_inp = atoi(argv[++i]);
			} else {
			     m_inp = atoi(argv[++i]);
			}
			break;
		case 'n':
			if (strncmp(argv[i]+1, "nx", 2) == 0) {
			     nx = atoi(argv[++i]);
			} else if (strncmp(argv[i]+1, "nx", 2) == 0) {
			     nphi = atoi(argv[++i]);
			} else if (strncmp(argv[i]+1, "ni", 2) == 0) {
			    n_inp_iter = atoi(argv[++i]);
			} else {
			    PR(ER, "%s: illegal flag '%s'\n",myname,argv[i]);
			    usage();
			}
			break;
		case 'h':
			if (strncmp(argv[i]+1, "hp", 2) == 0) {
				hp_grid = 1;  /* HEALPix */
			} else {
				usage();
			}
			break;
		case 't':
		       /*
			get_2_str(argv[++i], s1, s2);
			if(*s1 !='\0') th0=deg2rad(s1);
			if(*s2 !='\0') th1=deg2rad(s2);
		       */
			th0=deg2rad(argv[++i]);
			break;
		default:
			break;
		}
		break;
	case '+':
		switch(argv[i][1]) {
		case 'h':
		default:
			usage();
			break;
		}
		break;
	default:
		usage();
		break;
	}
    }

    return;
}

void usage()
{
PR(ER, "usage: %s [-lmax lmax] [-l l_fix] [-m m_fix] [-lp l_fix] [-mp m_fix]\n", myname);
PR(ER, "[-t dtheta(+-dtheta)] [-a alm_file]\n");
exit(2);
}
