#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define PR      fprintf
#define ER      stderr

int main(argc, argv)
int argc;
char **argv;
{
    register int i, j;
    char inp_file[161];
    int nx=0, nphi=0, npix_tot=0;
    int *nph = (int *)0;
    double *f = (double *)0, *x = (double *)0;
    int ffile_type_(char *);
    int flag;
    double vmin = 1.e+30, vmax = -1.e+30;

    inp_file[0] = '\0';

    strcpy(inp_file, argv[1]);

    /* type of file */
    flag = ffile_type_(inp_file);
    switch(flag) {
    case 0:
	fprintf(stderr, "It is not a GLESP map file. Sorry...\n");
	exit(1);
    case -1:
	fprintf(stderr, "It is neither an F- nor a FITS file. Sorry...\n");
	exit(1);
    case 1:
	break;
    }

    /* dimension of map from file */
    read_map_size_(&nx, &nphi, inp_file);

    /* catch the memory */
    if ((x=(double *)calloc(nx, sizeof *x)) == (double *)0) {
nomem:
	    fprintf(stderr, "Sorry, no memory: nx=%d, nphi=%d\n", nx, nphi);
	    exit(1);
    }
    if ((f=(double *)calloc(nx*nphi, sizeof *x)) == (double *)0)
	    goto nomem;
    if ((nph=(int *)calloc(nx, sizeof *nph)) == (int *)0)
	    goto nomem;

    /* map from file */
    read_map_(f, &nx, &nphi, nph, x, inp_file);

    for(i=0; i<nx; i++) {
	    register int ii = i*nphi;
	    npix_tot += nph[i];
	    for(j=0; j<nph[i]; j++) {
		if( f[ii+j] > vmax)  vmax = f[ii+j];
		if( f[ii+j] < vmin)  vmin = f[ii+j];
	    }
    }
    fprintf(stdout, "vmin = %15.8e, vmax=%15.8e, npix_tot=%d\n",
	     vmin, vmax, npix_tot);

    /* free memory */
    if (f != (double *)0) free((void *)f);
    if (x != (double *)0) free((void *)x);
    if (nph !=  (int *)0) free((void *)nph);

    exit(0);
}
